// ExternDlg.cpp : implementation file
//
////////////////////////////////////////////////////
////////////////////////////////////////////////////
// !!! this is not public domain !!!
// You can do what you want if it never hurt bonito.
// Otherwise, you will need the consent of Bonito.	
////////////////////////////////////////////////////
// RadioJet Open Source Project ExtIO_FiFi
// www.bonito.net/radiojet/opensource
////////////////////////////////////////////////////
////////////////////////////////////////////////////

#include "stdafx.h"
#include "GlobalTools.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CExternDlg dialog

CExternDlg::CExternDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CExternDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CExternDlg)
	m_corr = 0;
	m_scal = 0;
	//}}AFX_DATA_INIT
	FiFiReady=0;
	visibility=SWP_HIDEWINDOW;
}

CExternDlg::~CExternDlg()
{
	if (m_hWnd != NULL)
		{
		DestroyWindow();
		}
}

void CExternDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CExternDlg)
	DDX_Control(pDX, IDC_XCORR,			b_corrSpin);
	DDX_Control(pDX, IDC_XSCAL,			b_scalSpin);
	DDX_Control(pDX, IDC_LOFFS,			b_offsSpin);
	DDX_Control(pDX, IDC_HELP_ADJUST,	b_help);
	DDX_Control(pDX, IDC_WWW_FIFI,		b_web1);
	DDX_Control(pDX, IDC_WWW_FIFI2,		b_web2);
	DDX_Control(pDX, IDC_TEXT_CORR,		t_corr);
	DDX_Control(pDX, IDC_TEXT_SCAL,		t_scal);
	DDX_Control(pDX, IDC_TEXT_OFFS,		t_offs);
	DDX_Control(pDX, IDC_TXT_M,			t_man);
	DDX_Control(pDX, IDC_TXT_P,			t_pro);
	DDX_Control(pDX, IDC_TXT_S,			t_ser);
	DDX_Control(pDX, IDC_TXT_V,			t_ver);
										
	DDX_Text(pDX, IDC_TEXT_CORR,		m_corr);
	DDX_Text(pDX, IDC_TEXT_SCAL,		m_scal);
	DDX_Text(pDX, IDC_TEXT_OFFS,		m_offs);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CExternDlg, CDialog)
	//{{AFX_MSG_MAP(CExternDlg)
	ON_BN_CLICKED(IDC_WWW_FIFI,			GoWeb1)
	ON_BN_CLICKED(IDC_WWW_FIFI2,		GoWeb2)
	ON_WM_CLOSE()
	ON_WM_SHOWWINDOW()
	ON_WM_DESTROY()
	ON_NOTIFY(UDN_DELTAPOS, IDC_XCORR,	OnSetCorr)
	ON_NOTIFY(UDN_DELTAPOS, IDC_XSCAL,	OnSetScal)
	ON_NOTIFY(UDN_DELTAPOS, IDC_LOFFS,	OnSetOffs)
	ON_EN_UPDATE(IDC_TEXT_CORR,			OnUpdateTextCorr)
	ON_EN_UPDATE(IDC_TEXT_SCAL,			OnUpdateTextScal)
	ON_EN_UPDATE(IDC_TEXT_OFFS,			OnUpdateTextOffs)
	ON_BN_CLICKED(IDC_HELP_ADJUST,		OnHelpAdjust)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CExternDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	LOGFONT	mfont=		{	//SmallFont
					   -16,	//lfHeight;
						0,	//lfWidth;
						0,	//lfEscapement;
						0,	//lfOrientation;
				     1200,	//lfWeight;
						0,	//lfItalic;
						0,	//lfUnderline;
						0,	//lfStrikeOut;
						0,	//lfCharSet;
						0,	//lfOutPrecision;
						0,	//lfClipPrecision;
						0,	//lfQuality;
 DEFAULT_PITCH | FF_SWISS,	//lfPitchAndFamily;
		{"Arial\0    "}};	//lfFaceN

	mFont.CreateFontIndirect(&mfont);
	t_man.SetFont(&mFont);
	t_pro.SetFont(&mFont);

	b_help.SetBold(1); 
	b_help.SetColor(RGB(196,0,0),1);
	b_help.SetStyle(1);

	DWORD  dwGetVer = GetVersion();
	int WinVersion=LOBYTE(LOWORD(dwGetVer));

	if(WinVersion>5) 
		{
		 //window 7 have an light background
		m_hIcon = AfxGetApp()->LoadIcon(IDR_FIFI_ICON); 
		}
	else
		{
		//XP have an dark background
		m_hIcon = AfxGetApp()->LoadIcon(IDR_FIFI_ICON_XP);	
		}

	SetIcon(m_hIcon, FALSE);		// Set small icon

	// if myPara.msgHWND != NULL, then this ExtIO.dll is controlled by an application other than Winrad or clone.
	// Then, the communication with the Mircrosoft Message System is implemented - not the Mircrosoft untypical callback manner

	if(!myPara.msgHWND)
		{
		myPara.FreqCorrecture=GetProfileInt("PARAMETER","XtalFrqCorr",0);
		myPara.FreqCorrecture&=0xFFFF;
		myPara.ScaleCorrecture=GetProfileInt("PARAMETER","XtalScalingCorr",0);
		myPara.ScaleCorrecture&=0xFFFF;
		myPara.dBOffset=GetProfileInt("PARAMETER","dBOffset",0);
		myPara.dBOffset&=0xFFFF;
		}
	//else the parameter are all ready set of InitExtIOPara
	
	SetButtonState();

	FiFiReady=OpenFiFiBus();

	t_ser.SetWindowText(SerialNumber);
	char	txt[256];	
	if(Vmajor|Vminor) sprintf(txt,"Firmware Version %d.%d",Vmajor,Vminor);
	else strcpy(txt,"Firmware Version ?.?");
	t_ver.SetWindowText(txt);

	CRect re;
	GetWindowRect(re);
	re.top=GetProfileInt("POSITION","WindowTop",re.top);
	re.left=GetProfileInt("POSITION","WindowLeft",re.left);
	SetWindowPos(&wndTop,re.left,re.top,0,0,SWP_NOSIZE|visibility);

	return TRUE; 	              
}

void CExternDlg::OnCancel() 
{
	ShowWindow(SW_HIDE);
	if(myPara.msgHWND && myPara.msgSHOW) ::PostMessage(myPara.msgHWND,myPara.msgSHOW,SW_HIDE,(LPARAM)m_hWnd);
}
void CExternDlg::OnOK() {}
void CExternDlg::OnClose() 
{
	ShowWindow(SW_HIDE);
	if(myPara.msgHWND && myPara.msgSHOW) ::PostMessage(myPara.msgHWND,myPara.msgSHOW,SW_HIDE,(LPARAM)m_hWnd);
}

void CExternDlg::GoWeb1()
{
	ShellExecute(NULL, NULL,"http://o28.sischa.net/fifisdr", NULL,NULL, SW_SHOWNORMAL);
}

void CExternDlg::GoWeb2()
{
	ShellExecute(NULL, NULL,"http://www.bonito.net/manuals/radiojet/opensource", NULL,NULL, SW_SHOWNORMAL);
}

void CExternDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	myPara.SHOW=bShow; //set the status
	if(myPara.msgHWND) ::PostMessage(myPara.msgHWND,myPara.msgSHOW,bShow,nStatus);
}

void CExternDlg::Show_GUI(int show)
{
	if(show) visibility=SWP_SHOWWINDOW;
	else visibility=SWP_HIDEWINDOW;
	if(GetSafeHwnd())
		{
		if(show)
			{
			if(!IsWindowVisible()) ShowWindow(SW_SHOW);
			SetForegroundWindow();
			}
		else
			{
			ShowWindow(SW_HIDE);
			}
		}
}

void CExternDlg::SetButtonState() 
{
	m_corr=(int)myPara.FreqCorrecture;
	m_scal=(int)myPara.ScaleCorrecture;
	m_offs=(int)myPara.dBOffset;
	UpdateData(FALSE);	
}

void CExternDlg::OnDestroy() 
{
	CloseFiFiBus();
	
	if(!myPara.msgHWND)
		{
		WriteProfileInt("PARAMETER","XtalFrqCorr",myPara.FreqCorrecture);
		WriteProfileInt("PARAMETER","XtalScalingCorr",myPara.ScaleCorrecture);  
		WriteProfileInt("PARAMETER","dBOffset",myPara.dBOffset);
		}

	CRect re;
	GetWindowRect(re);
	WriteProfileInt("POSITION","WindowTop",re.top);
	WriteProfileInt("POSITION","WindowLeft",re.left);

	CDialog::OnDestroy();
}

void CExternDlg::OnSetCorr(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	
	myPara.FreqCorrecture-=pNMUpDown->iDelta;
	if(myPara.FreqCorrecture<-32767) myPara.FreqCorrecture=-32767;
	if(myPara.FreqCorrecture>32767) myPara.FreqCorrecture=32767;

	m_corr=(int)myPara.FreqCorrecture;
	UpdateData(FALSE);	

	if(myPara.msgHWND && myPara.msgCORR) ::PostMessage(myPara.msgHWND,myPara.msgCORR,m_corr,(LPARAM)m_hWnd);
	else SetFiFiFreq(lastFrq);
	*pResult = 0;
}

void CExternDlg::OnSetScal(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	
	myPara.ScaleCorrecture-=pNMUpDown->iDelta;
	if(myPara.ScaleCorrecture<-32767) myPara.ScaleCorrecture=-32767;
	if(myPara.ScaleCorrecture>32767) myPara.ScaleCorrecture=32767;

	m_scal=(int)myPara.ScaleCorrecture;
	UpdateData(FALSE);	
	if(myPara.msgHWND && myPara.msgSCAL) ::PostMessage(myPara.msgHWND,myPara.msgSCAL,m_scal,(LPARAM)m_hWnd);
	else SetFiFiFreq(lastFrq);
	*pResult = 0;
}

void CExternDlg::OnSetOffs(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	
	myPara.dBOffset-=pNMUpDown->iDelta;
	if(myPara.dBOffset<-135) myPara.dBOffset=135;
	if(myPara.dBOffset>135) myPara.dBOffset=135;

	m_offs=(int)myPara.dBOffset;
	UpdateData(FALSE);	
	if(myPara.msgHWND && myPara.msgOFFS) ::PostMessage(myPara.msgHWND,myPara.msgOFFS,m_offs,(LPARAM)m_hWnd);

	*pResult = 0;
}

void CExternDlg::OnUpdateTextCorr() 
{
	UpdateData(TRUE);
	if(m_corr<-32767) m_corr=-32767;
	if(m_corr>32767) m_corr=32767;
	myPara.FreqCorrecture=(short)m_corr;
	t_corr.SetFocus();
	UpdateData(FALSE);
	if(myPara.msgHWND && myPara.msgCORR) ::PostMessage(myPara.msgHWND,myPara.msgCORR,m_corr,(LPARAM)m_hWnd);
}

void CExternDlg::OnUpdateTextScal() 
{
	UpdateData(TRUE);
	if(m_scal<-32767) m_scal=-32767;
	if(m_scal>32767) m_scal=32767;
	myPara.ScaleCorrecture=(short)m_scal;
	t_scal.SetFocus();
	UpdateData(FALSE);
	if(myPara.msgHWND && myPara.msgSCAL) ::PostMessage(myPara.msgHWND,myPara.msgSCAL,m_scal,(LPARAM)m_hWnd);
}

void CExternDlg::OnUpdateTextOffs() 
{
	UpdateData(TRUE);
	if(m_offs<-135) m_offs=-135;
	if(m_offs>135) m_offs=135;
	myPara.dBOffset=(short)m_offs;
	t_offs.SetFocus();
	UpdateData(FALSE);
	if(myPara.msgHWND && myPara.msgOFFS) ::PostMessage(myPara.msgHWND,myPara.msgOFFS,m_offs,(LPARAM)m_hWnd);
}

#include "HelpAdust.h"
void CExternDlg::OnHelpAdjust() 
{
	CHelpAdust dlg;
	dlg.DoModal();
}
