// IFScopeControl.cpp : implementation file
//
////////////////////////////////////////////////////
////////////////////////////////////////////////////
// !!! this is not public domain !!!
// You can do what you want if it never hurt bonito.
// Otherwise, you will need the consent of Bonito.	
////////////////////////////////////////////////////
// RadioJet Open Source Project RJ10FiFi
// www.bonito.net/radiojet/opensource
////////////////////////////////////////////////////
////////////////////////////////////////////////////

#include "stdafx.h"
#include "GlobalTools.h"
#include "GetColorDlg.h"
#include "IFScopeControl.h"
#include "MyClasses/TimeUTC.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


#define ledMCS		led[0]
#define ledFAC		led[1]
#define ledSDC		led[2]
#define ledFSYNC	led[3]
#define ledTSYNC	led[4]
#define ledIO		led[5]

/////////////////////////////////////////////////////////////////////////////
// IFScopeControl dialog


IFScopeControl::IFScopeControl(CWnd* pParent /*=NULL*/)
	: CDialog(IFScopeControl::IDD, pParent)
{
	//{{AFX_DATA_INIT(IFScopeControl)
	//}}AFX_DATA_INIT
	amplChannel=CurveLo=ATTonoff=CurveStyle=lastFrq=-1;
	IFGainLevel=16;
	IFGainOff=1;
	m_ATT=0;
	InDeviceSelect=0;
	DRMInfoOFF=1;
	flckLanguageIdx=flckCountryIdx=flckProgrammTypeIdx=flckServiceID=flckStereoMono=-1;
}

void IFScopeControl::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(IFScopeControl)
	DDX_Control(pDX, IDC_COMBO1,			m_SoundDevice);
	DDX_Control(pDX, IDC_AMPL_POTI,			p_Ampl);
	DDX_Control(pDX, IDC_WIDTH_POTI,		p_Width);
	DDX_Control(pDX, IDC_TOP_LEVEL,			p_TopLevel);
	DDX_Control(pDX, IDC_TOP_AMPL,			p_TopAmpl);
	DDX_Control(pDX, IDC_SCALE_POTI,		p_DecScale);
	DDX_Control(pDX, IDC_LEVEL_POTI,		p_DecLevel);
	DDX_Control(pDX, IDC_DELAY_POTI,		p_Delay);
	DDX_Control(pDX, IDC_REPEAT_POTI,		p_Repeat);

	DDX_Control(pDX, IDC_PA_TOP_LEVEL,		pan_TopLevel);
	DDX_Control(pDX, IDC_PA_TOP_AMPL,		pan_TopAmpl);
	DDX_Control(pDX, IDC_PA_SCALE_POTI,		pan_DecScale);
	DDX_Control(pDX, IDC_PA_LEVEL_POTI,		pan_DecLevel);
	DDX_Control(pDX, IDC_PA_DELAY_POTI,		pan_Delay);
	DDX_Control(pDX, IDC_PA_REPEAT_POTI,	pan_Repeat);

	DDX_Control(pDX, IDC_PA_TOP_DEC,		b_panDEC);
	DDX_Control(pDX, IDC_PA_TOP_TSV,		b_panTSV);
	DDX_Control(pDX, IDC_DEC_OFFS_SMALL,	b_small);
	DDX_Control(pDX, IDC_DEC_OFFS_LARGE,	b_large);
	DDX_Control(pDX, IDC_DC_CORRECTION,		b_DCcorr);


	DDX_Control(pDX, IDC_IF_CONTROL,		m_View);
	DDX_Control(pDX, IDC_IF_TOP_OFF,		b_topOFF);
	DDX_Control(pDX, IDC_IFSTYLE_TOP_LIN,	b_topLIN);
	DDX_Control(pDX, IDC_IFSTYLE_TOP_TSV,	b_topTSV);
	DDX_Control(pDX, IDC_IFSTYLE_LIN,		b_LIN);
	DDX_Control(pDX, IDC_IFSTYLE_TSV,		b_TSV);
	DDX_Control(pDX, IDC_PANORAMA_VIEW,		b_ExternView);
	DDX_Control(pDX, IDC_EXPAND,			b_EXP);
	DDX_Control(pDX, IDC_CHANGE_COL,		b_COL);
	DDX_Control(pDX, IDC_SAMPLE_RATE_48,	b_48);
	DDX_Control(pDX, IDC_SAMPLE_RATE_96,	b_96);
	DDX_Control(pDX, IDC_SAMPLE_RATE_192,	b_192);

	DDX_Control(pDX, IDC_GB1,				gb1);
	DDX_Control(pDX, IDC_GB3,				gb3);
	DDX_Control(pDX, IDC_GB4,				drmOffset);
	DDX_Control(pDX, IDC_GB9,				gb9);
	DDX_Control(pDX, IDC_UTIL_DCFRQ,		s_DCFRQ);
	DDX_Control(pDX, IDC_UTIL_T_DCFRQ,		t_DCFRQ);
	DDX_Control(pDX, IDC_UTIL_SFRQ,			s_SFRQ);
	DDX_Control(pDX, IDC_UTIL_T_SFRQ,		t_SFRQ);

	DDX_Control(pDX, IDC_DRM_STATION_NAME,	StationName);
	DDX_Control(pDX, IDC_DRM_LANGUAGE,		Language);
	DDX_Control(pDX, IDC_DRM_COUNTRY,		Country);
	DDX_Control(pDX, IDC_DRM_STATION_ID,	StationID);
	DDX_Control(pDX, IDC_DRM_PROGRAM_TYPE,	ProgramType);
	DDX_Control(pDX, IDC_DRM_TEXT_MESSAGES,	TextMessages);
	DDX_Control(pDX, IDC_DRM_STEREOMONO,	StereoMono);
	DDX_Control(pDX, IDC_DRM_IMAGE,			DRMimage);
	DDX_Control(pDX, IDC_SHOW_EXT_DLG,		b_ExtDLG);
	//}}AFX_DATA_MAP

	DDX_Control(pDX, IDC_DESIGN_1,			b_design[0]);
	DDX_Control(pDX, IDC_DESIGN_2,			b_design[1]);
	DDX_Control(pDX, IDC_DESIGN_3,			b_design[2]);

	DDX_Control(pDX, IDC_UTIL_LED_MSC,		led[0]);
	DDX_Control(pDX, IDC_UTIL_LED_FAC,		led[1]);
	DDX_Control(pDX, IDC_UTIL_LED_SDC,		led[2]);
	DDX_Control(pDX, IDC_UTIL_LED_FRM,		led[3]);
	DDX_Control(pDX, IDC_UTIL_LED_ACQ,		led[4]);
	DDX_Control(pDX, IDC_UTIL_LED_IO,		led[5]);
}


BEGIN_MESSAGE_MAP(IFScopeControl, CDialog)
	//{{AFX_MSG_MAP(IFScopeControl)
	ON_BN_CLICKED(IDC_IF_TOP_OFF,		OnIfTopOff)
	ON_BN_CLICKED(IDC_IFSTYLE_LIN,		OnIfstyleLin)
	ON_BN_CLICKED(IDC_IFSTYLE_TOP_LIN,	OnIfstyleTopLin)
	ON_BN_CLICKED(IDC_IFSTYLE_TOP_TSV,	OnIfstyleTopTsv)
	ON_BN_CLICKED(IDC_IFSTYLE_TSV,		OnIfstyleTsv)
	ON_BN_CLICKED(IDC_EXPAND,			OnExpandWindow)
	ON_BN_CLICKED(IDC_DESIGN_1,			OnDesign1)
	ON_BN_CLICKED(IDC_DESIGN_2,			OnDesign2)
	ON_BN_CLICKED(IDC_DESIGN_3,			OnDesign3)
	ON_BN_CLICKED(IDC_SAMPLE_RATE_48,	OnSet48)
	ON_BN_CLICKED(IDC_SAMPLE_RATE_96,	OnSet96)
	ON_BN_CLICKED(IDC_SAMPLE_RATE_192,	OnSet192)
	ON_BN_CLICKED(IDC_CHANGE_COL,		OnChangeColor)
	ON_BN_CLICKED(IDC_PANORAMA_VIEW,	OnViewPamorama)
	ON_CBN_SELCHANGE(IDC_COMBO1,		OnSelchangeCombo1)
	ON_BN_CLICKED(IDC_DRM_IMAGE,		OnAbout)
	ON_BN_CLICKED(IDC_DEC_OFFS_SMALL,	OnSetSmall)
	ON_BN_CLICKED(IDC_DEC_OFFS_LARGE,	OnSetLarge)
	ON_BN_CLICKED(IDC_DC_CORRECTION,	OnDCcorrection)
	ON_BN_CLICKED(IDC_PA_TOP_DEC,		OnSetTopDEC)
	ON_BN_CLICKED(IDC_PA_TOP_TSV,		OnSetTopTSV)
	ON_BN_CLICKED(IDC_SHOW_EXT_DLG,		OnShowExtDialog)
	ON_WM_CTLCOLOR()
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_POTICHANGE,			OnPotiChange)
	ON_MESSAGE(WM_RBCLICK,				OnRButtonClick)
	ON_MESSAGE(WM_START_ACTION,			StartAction)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// IFScopeControl message handlers

/*BOOL IFScopeControl::PreTranslateMessage(MSG* pMsg) 
{
	if(pMsg->message ==WM_MOUSEMOVE)
		{
		if(m_tooltip.m_hWnd) m_tooltip.RelayEvent(pMsg);
		}	
	return CDialog::PreTranslateMessage(pMsg);
}*/

BOOL IFScopeControl::OnInitDialog() 
{
	CDialog::OnInitDialog();

	TextMessages.SetFont(&minifont);

	p_Delay.Init("Delay",100,2,NULL,SET_TOP);
	p_Ampl.Init("Bright",255,13,NULL,SET_LEFT);
	p_Width.Init("Width",24000,1000,NULL,SET_RIGHT); //spectrum band width in 24 steps
	p_Width.setValues=1; //view all times the value
	p_DecScale.Init("Scale",200,10,NULL,SET_LEFT);
	p_DecLevel.Init("Level",200,5,NULL,SET_TOP);
	p_Repeat.Init("Repeat",26,1,NULL,SET_TOP);
	p_TopLevel.Init("Level",540,10,NULL,SET_LEFT);
	p_TopAmpl.Init("Ampl",540,10,NULL,SET_LEFT);

	pan_TopAmpl.Init("Ampl",540,10,NULL,SET_LEFT);
	pan_TopLevel.Init("Level",540,10,NULL,SET_LEFT);
	pan_Delay.Init("Delay",100,2,NULL,SET_TOP);
	pan_Repeat.Init("Repeat",26,1,NULL,SET_TOP);
	pan_DecScale.Init("Scale",200,10,NULL,SET_LEFT);
	pan_DecLevel.Init("Level",200,5,NULL,SET_TOP);

	myIFStyle.m_ampl=AfxGetApp()->GetProfileInt("SCOPE","Ampl",0);
	myIFPara.width=AfxGetApp()->GetProfileInt("SCOPE","Width",IF_SAMPLE_FRQ>>1);
	myIFPara.pos=AfxGetApp()->GetProfileInt("SCOPE","Position",0);
	myIFStyle.m_style=AfxGetApp()->GetProfileInt("SCOPE","Style",IF_STYLE_DEC);

	myIFStyle.topAmpl=AfxGetApp()->GetProfileInt("SCOPE","TopAmpl",0);
	myIFStyle.topLevel=AfxGetApp()->GetProfileInt("SCOPE","TopLevel",0);
	myIFStyle.topStyle=AfxGetApp()->GetProfileInt("SCOPE","TopStyle",IF_STYLE_TOP_TIV);
	myIFStyle.m_smoothing=AfxGetApp()->GetProfileInt("SCOPE","Delay",50);
	myIFStyle.topOFF=AfxGetApp()->GetProfileInt("SCOPE","TopOFF",0);
	myIFStyle.topYPos=AfxGetApp()->GetProfileInt("SCOPE","TopYPos",0);
	myIFStyle.m_DecLevel=AfxGetApp()->GetProfileInt("SCOPE","DecLevel",100);
	myIFStyle.m_DecScale=AfxGetApp()->GetProfileInt("SCOPE","DecScale",0);
	myIFStyle.m_repeatation=AfxGetApp()->GetProfileInt("SCOPE","repeat",13);

	myPanoramaStyle.topAmpl=AfxGetApp()->GetProfileInt("PANORAMA","TopAmpl",0);
	myPanoramaStyle.topLevel=AfxGetApp()->GetProfileInt("PANORAMA","TopLevel",0);
	myPanoramaStyle.m_DecLevel=AfxGetApp()->GetProfileInt("PANORAMA","DecLevel",100);
	myPanoramaStyle.m_DecScale=AfxGetApp()->GetProfileInt("PANORAMA","DecScale",0);
	myPanoramaStyle.m_smoothing=AfxGetApp()->GetProfileInt("PANORAMA","Delay",50);
	myPanoramaStyle.topStyle=AfxGetApp()->GetProfileInt("PANORAMA","TopStyle",IF_STYLE_TOP_TIV);

	//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	//!!!! it was a big problem, to find out the supid error!!!!!!!
	//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	//a stupid mistake, too late to correct it, therfore:
	//the device name of Version 1 = "FiFiSDR Soundcard"
	//the device name of Version 2 = "FiFi-SDR Soundcard"
	///////////////////////////////////////////////////////////////

	myExtRxPara.IQ_default=1; //load a default data set 
	myExtRxPara.IQ_type=0;
	PepareExtIQDataSet(&myExtRxPara);

	
	//myExtRxPara.IQ_mode bring back the FiFi Version (not the Software Version)
	// see the real routine of the RJ10.DLL
/*
int CExtIOIn::GetDefaultFiFi(EXT_IQRX *extRX)
{
	for(int i=0; i<waveInGetNumDevs(); i++)
		{
		CString DevName=GetDevName(i);
		strcpy(extRX->IQ_SNDname,"Complex Baseband (I/Q)");
		if(strstrMixerName(DevName.GetBuffer(0),extRX->IQ_SNDname)) return 2;//on WIN 7,8 Computer
		strcpy(extRX->IQ_SNDname,"FiFi-SDR Soundcard");
		if(strstrMixerName(DevName.GetBuffer(0),extRX->IQ_SNDname)) return 3; //only on XP-Computer
		strcpy(extRX->IQ_SNDname,"FiFiSDR Soundcard");
		if(strstrMixerName(DevName.GetBuffer(0),extRX->IQ_SNDname)) return 1;//on booth Computer !! a good name for all computer
		}

	return 0
}*/

	if(myExtRxPara.IQ_mode>1) //myExtRxPara.IQ_mode == 2 then 
	//Version 2 of FiFi-SDR  = 192000 SampleVersion
	//else Version 1 the old FiFiSDR
		{
		mTitle2="Radio-Control and Spectrosope for I/Q-Receiver FiFI-SDR OV Lennestadt - (Open Source Example of Bonito RJ10.DLL - 2.Version)";
		}
	else 	mTitle2="Radio-Control and Spectrosope for I/Q-Receiver FiFI-SDR OV Lennestadt - (Open Source Example of Bonito RJ10.DLL - 1.Version)";

	myExtRxPara.dBLevelOffset=AfxGetApp()->GetProfileInt("PANORAMA","dBLevelOffset",myExtRxPara.dBLevelOffset);
	myExtRxPara.XtalFrqCorr=AfxGetApp()->GetProfileInt("PANORAMA","XtalFrqCorr",0);
	myExtRxPara.XtalScalingCorr=AfxGetApp()->GetProfileInt("PANORAMA","XtalScalingCorr",0);

	myExtRxPara.IQ_onoff=AfxGetApp()->WriteProfileInt("PANORAMA","IQ_onoff",0);
	myExtRxPara.IQ_type=1; //the type is all times =1 FiFI-SDR;
	
	myExtRxPara.IQ_mode=AfxGetApp()->GetProfileInt("PANORAMA","IQ_mode",1); //default = 96 kSamples
	myExtRxPara.IQ_SNDinType=AfxGetApp()->GetProfileInt("PANORAMA","IQ_SNDinType",myExtRxPara.IQ_SNDinType);
	myExtRxPara.IQ_DCcorr=AfxGetApp()->GetProfileInt("PANORAMA","IQ_DCcorr",myExtRxPara.IQ_DCcorr);
	strcpy(myExtRxPara.IQ_SNDname,AfxGetApp()->GetProfileString("PANORAMA","IQ_SNDname",myExtRxPara.IQ_SNDname));

	p_Delay.Set(myIFStyle.m_smoothing);

	SetSamples(myExtRxPara.IQ_mode,0); 
	SetDecScale(myIFStyle.m_DecScale);
	SetDecLevel(myIFStyle.m_DecLevel);
	SetRepeat(myIFStyle.m_repeatation); 

	p_Ampl.Set(myIFStyle.m_ampl);
	p_Width.Set(myIFPara.width);
	b_topOFF.SetCheck(myIFStyle.topOFF);

	SetTopAmpl(myIFStyle.topAmpl);
	SetTopLevel(myIFStyle.topLevel);

	SetPanTopLevel(myPanoramaStyle.topAmpl);
	SetPanTopAmpl(myPanoramaStyle.topLevel);
	SetPanDecLevel(myPanoramaStyle.m_DecLevel);
	SetPanDecScale(myPanoramaStyle.m_DecScale);
	SetPanDelay(myPanoramaStyle.m_smoothing);
	SetPanRepeat(myIFStyle.m_repeatation); 

	//set saturation color of COL_KNOBFACE[selectedDesign]
	b_design[0].SetColor(desCol[0],1); 
	b_design[1].SetColor(desCol[1],1); 
	b_design[2].SetColor(desCol[2],1); 

	b_design[0].SetStyle(TAB_BOTTON);
	b_design[1].SetStyle(TAB_BOTTON);
	b_design[2].SetStyle(TAB_BOTTON);

	b_COL.SetImage(IDB_PALETTE);
	ledMCS.mini=ledFAC.mini=ledSDC.mini=ledFSYNC.mini=ledTSYNC.mini=ledIO.mini=1;

	//now init the View 
	m_View.Init();	

	SetDesingState();
	SetAllButtons();

	myPanorama.Create(IDD_PANORAMA_CTRL,this);
	if(lang==7) 
		{
		DRMimage.SetImage(IDB_DRM_IMAGE);
		TextMessages.SetWindowText("Nicht die Gre des Empfngers macht ein gutes SDR aus,\nsondern seine Software, die zeigt was in ihm steckt.");
		}
	else
		{
		DRMimage.SetImage(IDB_DRM_IMAGE1);
		TextMessages.SetWindowText("Not the size of the receiver indicates a good SDR.\nNo, only his software shows what it can really do.");
		}
	DRMimage.m_bButtonStyle=1;
	
	SetDeviceList();

	CRect re,ra;

	GetDlgItem(IDC_GB4)->GetWindowRect(ra);
	ScreenToClient(ra);
	re.left=ra.right+5;
	re.top=ra.top;
	GetDlgItem(IDC_GB6)->GetWindowRect(ra);
	ScreenToClient(ra);
	re.bottom=ra.bottom;
	GetDlgItem(IDC_GB2)->GetWindowRect(ra);
	ScreenToClient(ra);
	re.right=ra.left-5;

	m_Rec.Create(IDD_IQ_RECORDER,this);
	m_Rec.SetWindowPos(NULL,re.left,re.top,re.Width(),re.Height(),MOVEALL);

	StationName.SetFont(&BigFont);
	Language.SetFont(&DRMfont);
	Country.SetFont(&DRMfont);
	ProgramType.SetFont(&DRMfont);
	StationID.SetFont(&DRMfont);
	StereoMono.SetFont(&DRMfont);
	DrawDrmImage();
	SetExtIODialog(myExtRxPara.IQ_showGUI);
	SetExternView(myPanorama.IsWindowVisible()); 

	CWnd*		pTemp= GetTopWindow();
	WINPOSION	wp;
	int			set;
  	while (pTemp)
		{
		set=0;
		switch(pTemp->GetDlgCtrlID())
			{
			case	IDC_IF_CONTROL:
			case	IDC_GB1:
			case	IDC_IF_TOP_OFF:
			case	IDC_IFSTYLE_TOP_LIN:
			case	IDC_IFSTYLE_TOP_TSV:
			case	IDC_TOP_LEVEL:
			case	IDC_TOP_AMPL: set=1;
			}
		if(!set)
			{
			pTemp->GetWindowRect(&wp.rect);
			ScreenToClient(&wp.rect);
			wp.win=pTemp;
			myWinList.Add(wp);
			}
		pTemp = pTemp->GetNextWindow();
        }

	m_View.GetWindowRect(myViewRect);
	ScreenToClient(myViewRect);

	return TRUE;               
}

LRESULT IFScopeControl::StartAction(WPARAM wParam, LPARAM lParam) 
{
	Sleep(1000); 
	SetDeviceList();
	return NULL;
}

void IFScopeControl::SetDeviceList()
{

	InDeviceList &mDeviceList=GetInputDeviceList();
	myInDeviceList.RemoveAll();

	myInDeviceList.SetSize(mDeviceList.GetSize());
	memcpy(myInDeviceList.GetData(),mDeviceList.GetData(),sizeof(IN_DEVICE_INFO)*mDeviceList.GetSize());

	m_SoundDevice.ResetContent();
	InDeviceSelect=-1;
	for(int i=0; i<myInDeviceList.GetSize(); i++)
		{
		m_SoundDevice.AddString(myInDeviceList[i].name);
		if(strstr(myInDeviceList[i].name,myExtRxPara.IQ_SNDname)) InDeviceSelect=i;
		}
	if(InDeviceSelect!=-1) 
		{
		m_SoundDevice.SetCurSel(InDeviceSelect);
		myExtRxPara.IQ_reset=1;
		SetSamples(myExtRxPara.IQ_mode);
		}
	else 
		{
		m_View.ClearView();
		myPanorama.m_View.ClearView();
		}
}

void IFScopeControl::SetDesingState()
{
	for(int i=0; i<3; i++)
		{
		if(i==selectedDesign) b_design[i].SetCheck(1);
		else  b_design[i].SetCheck(0);
		}
}

void IFScopeControl::SetAllButtons(int set)
{
	b_DCcorr.SetCheck(myExtRxPara.IQ_DCcorr);
	SetDesingState();
	SetStyleState();
}

LRESULT IFScopeControl::OnPotiChange(WPARAM wParam, LPARAM lParam)
{
	int x=(int)lParam;
	int pos=lParam;

	if((HWND)wParam==p_Ampl.m_hWnd)
		{
		SetAmpl(lParam);
		}
	else if((HWND)wParam==p_Width.m_hWnd)
		{
		SetWidth(lParam);
		}

	else if((HWND)wParam==p_Delay.m_hWnd)
		{
		SetDelay(pos);
		}
	else if((HWND)wParam==p_Repeat.m_hWnd) 
		{
		SetRepeat(pos); 
		}

	else if((HWND)wParam==pan_Delay.m_hWnd)
		{
		SetPanDelay(pos);
		}
	else if((HWND)wParam==pan_Repeat.m_hWnd) 
		{
		SetPanRepeat(pos); 
		}

	else if((HWND)wParam==p_TopLevel.m_hWnd)
		{
		SetTopLevel(lParam);
		}
	else if((HWND)wParam==p_TopAmpl.m_hWnd)
		{
		SetTopAmpl(lParam);
		}
	else if((HWND)wParam==p_DecScale.m_hWnd) 
		{
		SetDecScale(lParam);
		}
	else if((HWND)wParam==p_DecLevel.m_hWnd) 
		{
		SetDecLevel(lParam);
		}

	else if((HWND)wParam==pan_TopLevel.m_hWnd)
		{
		SetPanTopLevel(lParam);
		}
	else if((HWND)wParam==pan_TopAmpl.m_hWnd)
		{
		SetPanTopAmpl(lParam);
		}
	else if((HWND)wParam==pan_DecScale.m_hWnd) 
		{
		SetPanDecScale(lParam);
		}
	else if((HWND)wParam==pan_DecLevel.m_hWnd) 
		{
		SetPanDecLevel(lParam);
		}


	return NULL;
}

void IFScopeControl::SetDecLevel(int level) 
{
	myIFStyle.m_DecLevel=level;
	p_DecLevel.Set(level);
	m_View.SetDecLevel(level);
}

void IFScopeControl::SetDecScale(int scale) 
{
	myIFStyle.m_DecScale=scale;
	p_DecScale.Set(scale);
	m_View.SetDecScale(scale);
}

void IFScopeControl::SetTopLevel(int level)
{
	m_View.SetTLevel(level);
	p_TopLevel.Set(level);
}

void IFScopeControl::SetTopAmpl(int ampl)
{
	m_View.SetTAmpl(ampl);
	p_TopAmpl.Set(ampl);
}

void IFScopeControl::SetDelay(int delay) 
{
	myIFStyle.m_smoothing=delay;
	p_Delay.Set(delay);
	m_View.SetDelay(delay);
}
void IFScopeControl::SetRepeat(int repeat) 
{
	myIFStyle.m_repeatation=(BYTE)repeat;
	myPanoramaStyle.m_repeatation=(BYTE)repeat;
	pan_Repeat.Set(repeat);
	p_Repeat.Set(repeat);
	myMainFrm->SetRepeatation(repeat);
}

void IFScopeControl::SetPanDecLevel(int level) 
{
	pan_DecLevel.Set(level);
	myPanoramaView.SetDecLevel(level);
}

void IFScopeControl::SetPanDecScale(int scale) 
{
	pan_DecScale.Set(scale);
	myPanoramaView.SetDecScale(scale);
}

void IFScopeControl::SetPanTopLevel(int level)
{
	pan_TopLevel.Set(level);
	myPanoramaView.SetTLevel(level);
}

void IFScopeControl::SetPanTopAmpl(int ampl)
{
	pan_TopAmpl.Set(ampl);
	myPanoramaView.SetTAmpl(ampl);
}

void IFScopeControl::SetPanDelay(int delay) 
{
	pan_Delay.Set(delay);
	myPanoramaView.SetDelay(delay);
}

void IFScopeControl::SetPanRepeat(int repeat) 
{
	SetRepeat(repeat);
}

void IFScopeControl::SetWidth(int pos)
{
	if(pos <1000) pos=1000;
	int mid=((myIFPara.m_hi+myIFPara.m_lo)/2)-(pos/2);
	if(mid<0) mid=0;
	myIFPara.pos=mid;
	myIFPara.width=pos;
	SetFilterParameter();
}

void IFScopeControl::SetPosition(int pos)
{
	myIFPara.pos=pos;
	SetFilterParameter();
}

void IFScopeControl::PotiNormalisation()
{
	int lo,hi,max=IF_SAMPLE_FRQ>>1;;

	if(myIFPara.width >max) myIFPara.width	=max;
	if(myIFPara.pos  >max) myIFPara.pos	=max;
	if(myIFPara.width <1000) myIFPara.width	=1000;
	if(myIFPara.pos	<0) myIFPara.pos=0;

	lo=myIFPara.pos;
	hi=lo+myIFPara.width;
	if(hi>max)
		{
		lo=max-myIFPara.width;
		hi=lo+myIFPara.width;
		}
	
	myIFPara.width=hi-lo;
	myIFPara.pos=lo;

	int pos=(int)((float)myIFPara.width/20.f+.5f)*20;

	p_Width.Set(pos);
	p_Ampl.Set(myIFStyle.m_ampl);

	myIFPara.m_lo=int(lo);
	myIFPara.m_hi=int(hi);
}

void IFScopeControl::SetAmpl(int ampl) 
{	
	myIFStyle.m_ampl=ampl;
	p_Ampl.Set(ampl);
	m_View.SetAmpl(myIFStyle.m_ampl);
	m_View.RefreschWindow(2);
}

void IFScopeControl::SetFilterParameter() 
{
	PotiNormalisation();
	m_View.OnFilterChanged();
	m_View.RefreschWindow(2);
	myPanorama.m_View.OnFilterChanged();
	myPanorama.m_View.RefreschWindow(2);
}

void IFScopeControl::OnIfTopOff() 
{
	if(myIFStyle.topOFF) myIFStyle.topOFF=0;
	else myIFStyle.topOFF=1;
	b_topOFF.SetCheck(myIFStyle.topOFF);
	m_View.ReSizeSpectrum(3);
}

void IFScopeControl::OnIfstyleTopLin() 
{
	if(myIFStyle.topStyle==IF_STYLE_TOP_DEC) myIFStyle.topStyle=IF_STYLE_TOP_TIV;
	else myIFStyle.topStyle=IF_STYLE_TOP_DEC;
	SetStyleState();
}

void IFScopeControl::OnIfstyleTopTsv() 
{
	if(myIFStyle.topStyle==IF_STYLE_TOP_TIV) myIFStyle.topStyle=IF_STYLE_TOP_DEC;
	else myIFStyle.topStyle=IF_STYLE_TOP_TIV;
	SetStyleState();
}

void IFScopeControl::OnIfstyleLin() 
{
	if(myIFStyle.m_style==IF_STYLE_DEC) myIFStyle.m_style=IF_STYLE_TIV;
	else myIFStyle.m_style=IF_STYLE_DEC;
	SetStyleState();
}

void IFScopeControl::OnIfstyleTsv() 
{
	if(myIFStyle.m_style==IF_STYLE_TIV) myIFStyle.m_style=IF_STYLE_DEC;
	else myIFStyle.m_style=IF_STYLE_TIV;
	SetStyleState();
}

void IFScopeControl::SetStyleState() 
{
	//set the state of all the style buttons
	b_topOFF.SetCheck(myIFStyle.topOFF);
	b_LIN.SetCheck(myIFStyle.m_style==IF_STYLE_DEC);
	b_TSV.SetCheck(myIFStyle.m_style!=IF_STYLE_DEC);
	b_topLIN.SetCheck(myIFStyle.topStyle==IF_STYLE_TOP_DEC);
	b_topTSV.SetCheck(myIFStyle.topStyle!=IF_STYLE_TOP_DEC);

	b_panDEC.SetCheck(myPanoramaStyle.topStyle==IF_STYLE_TOP_DEC);
	b_panTSV.SetCheck(myPanoramaStyle.topStyle!=IF_STYLE_TOP_DEC);

	if(myIFStyle.m_style==IF_STYLE_DEC)
		{
		p_Ampl.EnableWindow(FALSE);	 //Ampitude on Lines is posible, but only for stupid people -> do not know the dBm scale is calibrated
		p_Delay.EnableWindow(TRUE);  //delay on Lines is now posible
		}
	else
		{
		p_Ampl.EnableWindow(TRUE);	 //on time spectrum is this like brighness
		p_Delay.EnableWindow(FALSE); //delay on time spectrum, does not look good
		}
}

void IFScopeControl::OnExpandWindow() 
{
	if(myMainFrm->m_MM==2) myMainFrm->Adjust(1);
	else myMainFrm->Adjust(2);
}

void IFScopeControl::Adjust(CRect &rect,int set) 
{
	CRect re;
	if(!NetBookFormat) 
		{
		SetWindowPos(NULL,rect.left,rect.top,rect.Width(),rect.Height(),SWP_SHOWWINDOW|MOVEALL);
		DRMimage.SetFocus();
		return;
		}

	//works only on Netbook Format <--- 1024 x 600

	int	Offset=0,show=SW_SHOW,i;
	if(set==2) 
		{
		Offset=NetBookFormat;
		show=SW_HIDE;
		}
		
	SetWindowPos(NULL,rect.left,rect.top,rect.Width(),rect.Height(),SWP_SHOWWINDOW|MOVEALL);

	gb1.ShowWindow(show);
	b_topOFF.ShowWindow(show);
	b_topLIN.ShowWindow(show);
	b_topTSV.ShowWindow(show);
	p_TopLevel.ShowWindow(show);
	p_TopAmpl.ShowWindow(show);

  	for(i=0; i<myWinList.GetSize(); i++)
		{
		re=myWinList[i].rect;
		myWinList[i].win->SetWindowPos(NULL,re.left,re.top-Offset,re.Width(),re.Height(),MOVEALL); 
        }
	b_EXP.GetWindowRect(re);
	ScreenToClient(re);
	myViewRect.bottom=re.bottom-1;

	m_View.SetWindowPos(NULL,myViewRect.left,myViewRect.top,myViewRect.Width(),myViewRect.Height(),NO_MOVE);
	DRMimage.SetFocus();
}

void IFScopeControl::SetDesign(int col) 
{
	for(int i=0; i<3; i++)
		{
		if(i==col) b_design[i].SetCheck(1);
		else  b_design[i].SetCheck(0);
		}
	InitGraficUtilitys(col);
	myMainFrm->RedrawWindow();
}

void IFScopeControl::OnDesign1() 
{
	SetDesign(0);
}

void IFScopeControl::OnDesign2() 
{
	SetDesign(1);
}

void IFScopeControl::OnDesign3() 
{
	SetDesign(2);
}

void IFScopeControl::SetSamples(int mode, int set) 
{
	myExtRxPara.IQ_mode=mode;
	if(set) 
		{
		SetExtIQData(&myExtRxPara);
		}

	b_48.SetCheck(0);
	b_96.SetCheck(0);
	b_192.SetCheck(0);

	switch(mode)
		{
		case	0: b_48.SetCheck(1);	break;
		default:
		case	1: b_96.SetCheck(1);	break;
		case    2: b_192.SetCheck(1);	break;
		}
	if(set) 
		{
		myPanorama.InitParameter(-1);
		}

}

void IFScopeControl::OnSet48() 
{
	SetSamples(0);	//48000 sample freq, 4096 samples per block 
}

void IFScopeControl::OnSet96() 
{
	SetSamples(1);	//96000 sample freq, 8192 samples per block
}

void IFScopeControl::OnSet192() 
{
	SetSamples(2); //192000 sample freq, 16384 samples per block
}


void IFScopeControl::OnChangeColor() 
{
	b_COL.SetCheck(1);
	GetColorDlg dlg(this);
	if(dlg.DoModal()==IDOK) 
		{
		b_design[0].SetColor(desCol[0],1); 
		b_design[1].SetColor(desCol[1],1); 
		b_design[2].SetColor(desCol[2],1); 
		}
	b_COL.SetCheck(0);
}

void IFScopeControl::OnViewPamorama() 
{
	myPanorama.ShowWindow(!myPanorama.IsWindowVisible());
	SetExternView(myPanorama.IsWindowVisible()); 
	AfxGetApp()->WriteProfileInt("PANORAMA","onoff",myPanorama.IsWindowVisible());
}

LRESULT IFScopeControl::OnRButtonClick(WPARAM wParam, LPARAM lParam) 
{
	if(wParam==IDC_PANORAMA_VIEW)
		{//reset the panorama window (maybe the window was outside of the screen)
		CRect myRect;
		myMainFrm->GetWindowRect(myRect);
		myRect.top=myRect.bottom-180; if(myRect.top<0) {myRect.top=0; myRect.bottom=180;}
		myPanorama.SetWindowPos(NULL,myRect.left,myRect.top,myRect.Width(),myRect.Height(),SWP_SHOWWINDOW|MOVEALL);
		b_ExternView.SetCheck(1);
		}

	return NULL;
}

void IFScopeControl::UpdateStatus()
{
	CString str;
	ledMCS.SetState(myRxSignalState.MSCState);		myMainFrm->led[0].SetState(myRxSignalState.MSCState);
	ledFAC.SetState(myRxSignalState.FACState);		myMainFrm->led[1].SetState(myRxSignalState.FACState);
	ledSDC.SetState(myRxSignalState.SDCState);		myMainFrm->led[2].SetState(myRxSignalState.SDCState);
	ledFSYNC.SetState(myRxSignalState.FSYNCState);
	ledTSYNC.SetState(myRxSignalState.TSYNCState);
	ledIO.SetState(myRxSignalState.IOState);		myMainFrm->led[3].SetState(myRxSignalState.IOState);

	// Show currend info if DRM in tracking mode
	if (myMainFrm->m_mode==REC_DRM && myRxSignalState.AcquiState)
		{
		// estimation of sample frequency offset 
		str.Format("%2.2f Hz (%d ppm)",myRxSignalState.rCurSamROffs,myRxSignalState.iCurSamROffs);
		s_SFRQ.SetWindowText(str);
		// DC frequency 
		str.Format("%.2f : %.2f Hz",myRxSignalState.rDCFrequency,myRxSignalState.rDCFrequency-12000);
		s_DCFRQ.SetWindowText(str);

		if(flckStationName.Compare(myRxSignalState.ServiceLabel))
			{
			flckStationName=myRxSignalState.ServiceLabel;
			StationName.SetWindowText(myRxSignalState.ServiceLabel);
			myMainFrm->drm_label.SetWindowText(myRxSignalState.ServiceLabel);
			}
		if(flckLanguageIdx!=myRxSignalState.LanguageIdx)
			{
			flckLanguageIdx=myRxSignalState.LanguageIdx;
			Language.SetWindowText(myLanguage[myRxSignalState.LanguageIdx].Name);
			}
		if(flckCountryIdx!=myRxSignalState.CountryIdx)
			{
			flckCountryIdx=myRxSignalState.CountryIdx;
			Country.SetWindowText(myCountries[myRxSignalState.CountryIdx].Name);
			}
		if(flckProgrammTypeIdx!=myRxSignalState.ProgrammTypeIdx)
			{
			flckProgrammTypeIdx=myRxSignalState.ProgrammTypeIdx;
			ProgramType.SetWindowText(myProgramTypes[myRxSignalState.ProgrammTypeIdx]);
			}
		if(flckServiceID!=myRxSignalState.iServiceID)
			{
			flckServiceID=myRxSignalState.iServiceID;
			str.Format("ID:%06X",myRxSignalState.iServiceID);
			StationID.SetWindowText(str);
			}
		if(flckTextMessages.Compare(myRxSignalState.TextMessages))
			{
			TextMessages.SetWindowText(myRxSignalState.TextMessages);
			flckTextMessages=myRxSignalState.TextMessages;
			}
		
		if(flckStereoMono!=myRxSignalState.ProgrammTypeIdx)
			{
			flckStereoMono=myRxSignalState.ProgrammTypeIdx;
			if(flckStereoMono==2 || flckStereoMono==3) StereoMono.SetWindowText("(Stereo)");
			else StereoMono.SetWindowText("(Mono)");
			}


		if(!DRMInfoOFF)
			{
			DRMInfoOFF=1;
			DRMimage.ShowWindow(SW_HIDE);
			StationName.ShowWindow(SW_SHOW);
			Language.ShowWindow(SW_SHOW);
			Country.ShowWindow(SW_SHOW);
			ProgramType.ShowWindow(SW_SHOW);
			StationID.ShowWindow(SW_SHOW);
			TextMessages.ShowWindow(SW_SHOW);
			StereoMono.ShowWindow(SW_SHOW);
			t_DCFRQ.ShowWindow(SW_SHOW);
			t_SFRQ.ShowWindow(SW_SHOW);
			s_DCFRQ.ShowWindow(SW_SHOW);
			s_SFRQ.ShowWindow(SW_SHOW);
			}

		}
	else
		{
		if(DRMInfoOFF)
			{
			str="          ";
			s_SFRQ.SetWindowText(str);
			s_DCFRQ.SetWindowText(str);
			StationName.SetWindowText(str);
			Language.SetWindowText(str);
			Country.SetWindowText(str);
			ProgramType.SetWindowText(str);
			StationID.SetWindowText(str);
			DrawDrmImage();
			if(lang==7) TextMessages.SetWindowText("Nicht die Gre des Empfngers macht ein gutes SDR aus,\nsondern seine Software, die zeigt was in ihm steckt.");
			else TextMessages.SetWindowText("Not the size of the receiver indicates a good SDR.\nNo, only his software shows what it can really do.");
			}
		}
}

void IFScopeControl::DrawDrmImage()
{
	myMainFrm->drm_label.SetWindowText("FiFi-SDR OV-Lennstadt - O28");
	StationName.ShowWindow(SW_HIDE);
	Language.ShowWindow(SW_HIDE);
	Country.ShowWindow(SW_HIDE);
	ProgramType.ShowWindow(SW_HIDE);
	StationID.ShowWindow(SW_HIDE);
	TextMessages.ShowWindow(SW_HIDE);
	t_DCFRQ.ShowWindow(SW_HIDE);
	t_SFRQ.ShowWindow(SW_HIDE);
	s_DCFRQ.ShowWindow(SW_HIDE);
	s_SFRQ.ShowWindow(SW_HIDE);
	StereoMono.ShowWindow(SW_HIDE);
	DRMimage.ShowWindow(SW_SHOW);
	DRMInfoOFF=0;
	flckServiceID=flckProgrammTypeIdx=flckCountryIdx=flckLanguageIdx=-1;
	flckStationName.Empty();
	flckTextMessages.Empty();
}

void IFScopeControl::OnSelchangeCombo1() 
{
	UpdateData(TRUE);
	InDeviceSelect=m_SoundDevice.GetCurSel();
	if(InDeviceSelect>=0 && InDeviceSelect<myInDeviceList.GetSize())
		{
		strcpy(myExtRxPara.IQ_SNDname,myInDeviceList[InDeviceSelect].name);
		myExtRxPara.IQ_SNDinType=myInDeviceList[InDeviceSelect].type&1;
		myExtRxPara.IQ_reset=1;
		SetSamples(myExtRxPara.IQ_mode);
		}
}

void IFScopeControl::OnAbout()
{
	DRMimage.SetCheck(1);
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();
	DRMimage.SetCheck(0);
}

void IFScopeControl::OnSetTopDEC() 
{
	myPanoramaStyle.topStyle=(short)IF_STYLE_TOP_DEC;
	myPanoramaView.RefreschWindow(2);
	b_panDEC.SetCheck(myPanoramaStyle.topStyle!=IF_STYLE_TOP_TIV);
	b_panTSV.SetCheck(myPanoramaStyle.topStyle==IF_STYLE_TOP_TIV);
}

void IFScopeControl::OnSetTopTSV() 
{
	myPanoramaStyle.topStyle=(short)IF_STYLE_TOP_TIV;
	myPanoramaView.RefreschWindow(2);
	b_panDEC.SetCheck(myPanoramaStyle.topStyle!=IF_STYLE_TOP_TIV);
	b_panTSV.SetCheck(myPanoramaStyle.topStyle==IF_STYLE_TOP_TIV);
}

void IFScopeControl::OnSetLarge() 
{
	SetPanDecScale(GetMyProfileInt("PANORAMA","DecScaleLarge",50)); 
	SetPanDecLevel(GetMyProfileInt("PANORAMA","DecLevelLarge",80)) ;
}

void IFScopeControl::OnSetSmall()
{
	SetPanDecScale(GetMyProfileInt("PANORAMA","DecScaleSmall",20)); 
	SetPanDecLevel(GetMyProfileInt("PANORAMA","DecLevelSmall",85)) ;
}

void IFScopeControl::OnDCcorrection()
{
	if(myExtRxPara.IQ_DCcorr) myExtRxPara.IQ_DCcorr=0;
	else myExtRxPara.IQ_DCcorr=1;
	SetExtIQData(&myExtRxPara);
	b_DCcorr.SetCheck(myExtRxPara.IQ_DCcorr);
}

void IFScopeControl::SetExtIODialog(int set) 
{
	if(b_ExtDLG.GetSafeHwnd())
		{
		if(!myExtRxPara.IQ_open)
			{
			b_ExtDLG.SetCheck(0);
			b_ExtDLG.SetImage(IDB_DLGBAR2);
			b_ExtDLG.EnableWindow(FALSE);
			}
		else
			{
			b_ExtDLG.EnableWindow(TRUE);
			b_ExtDLG.SetCheck(set);
			if(set) 
				{
				b_ExtDLG.SetImage(IDB_DLGBAR1);
				}
			else
				{
				b_ExtDLG.SetImage(IDB_DLGBAR);
				}
			}
		}
}

void IFScopeControl::SetExternView(int set) 
{
	if(b_ExternView.GetSafeHwnd())
		{
		b_ExternView.SetCheck(set);
		if(set) 
			{
			b_ExternView.SetImage(IDB_PANORAMA1);
			}
		else
			{
			b_ExternView.SetImage(IDB_PANORAMA);
			}
		}
}

void IFScopeControl::OnShowExtDialog() 
{
	if(myExtRxPara.IQ_showGUI) myExtRxPara.IQ_showGUI=0;
	else myExtRxPara.IQ_showGUI=1;
	myExtRxPara.IQ_showGUIex=1;
	SetExtIQData(&myExtRxPara);
	SetExtIODialog(myExtRxPara.IQ_showGUI);
}

