#if !defined(AFX_IFSCOPECONTROL_H__46CC71E4_4EDA_4600_8F34_A0E8DF0E1968__INCLUDED_)
#define AFX_IFSCOPECONTROL_H__46CC71E4_4EDA_4600_8F34_A0E8DF0E1968__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// IFScopeControl.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// IFScopeControl dialog

#include "MyClasses/MyIFView.h"
#include "MyClasses/MyPoti.h"
#include "MyClasses/MyButton.h"
#include "MyClasses/MyStateLED.h"
#include "MyClasses/MyDrmText.h"
#include "MyPanoramaCtrl.h"
#include "IQRecordCtrl.h"

class IFScopeControl : public CDialog
{
// Construction
public:
	IFScopeControl(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(IFScopeControl)
	enum { IDD = IDD_IF_SCOPE_CTRL };
	CComboBox	m_SoundDevice;
	MyPoti		p_Delay;
	MyPoti		p_Ampl;
	MyPoti		p_Width;
	MyPoti		p_TopLevel;
	MyPoti		p_TopAmpl;
	MyPoti		p_DecScale;
	MyPoti		p_DecLevel;
	MyPoti		p_Repeat;

	MyPoti		pan_TopLevel;
	MyPoti		pan_TopAmpl;
	MyPoti		pan_DecScale;
	MyPoti		pan_DecLevel;
	MyPoti		pan_Delay;
	MyPoti		pan_Repeat;

	MyButton	b_panDEC;
	MyButton	b_panTSV;
	MyButton	b_small;
	MyButton	b_large;
	MyButton	b_DCcorr;

	MyIFView	m_View;
	MyButton	b_topOFF;
	MyButton	b_topLIN;
	MyButton	b_topTSV;
	MyButton	b_LIN;
	MyButton	b_TSV;
	MyButton	b_ExternView;
	MyButton	b_About;
	MyButton	b_EXP;
	MyButton	b_COL;
	MyButton	b_48;
	MyButton	b_96;
	MyButton	b_192;

	CStatic		s_DCFRQ;
	CStatic		t_DCFRQ;
	CStatic		s_SFRQ;	
	CStatic		t_SFRQ;

	CStatic		Language;
	CStatic		Country;
	CStatic		ProgramType;
	CStatic		StationID;
	CStatic		StationName;
	CStatic		TextMessages;
	CStatic		StereoMono;

	CStatic		gb1;
	CStatic		gb9;
	CStatic		gb4;
	CStatic		gb3;
	CStatic		drmOffset;
	MyButton	DRMimage;
	MyButton	b_ExtDLG;
	//}}AFX_DATA
	MyStateLED		led[6];
	MyButton		b_design[3];
	MyPanoramaCtrl	myPanorama;

	int			m_scale,m_ATT,IFGainOff,IFGainLevel,InDeviceSelect,DRMInfoOFF;
	int			CurveStyle,CurveHi,CurveLo,CurveWidth,CurvePos,amplChannel,ATTonoff,lastFrq;
	int			flckLanguageIdx,flckCountryIdx,flckProgrammTypeIdx,flckServiceID,flckStereoMono; //flickerfix
	CString		flckStationName,flckTextMessages;
	void		SetDeviceList();
	void		SetAmpl(int ampl);
	void		SetWidth(int pos);
	void		SetPosition(int pos);
	void		PotiNormalisation();
	void		SetFilterParameter(); 
	void		SetAllButtons(int set=0);
	void		SetStyleState();
	void		SetDesingState();
	void		SetDesign(int col);

	void		SetDelay(int delay);
	void		SetTopLevel(int level);
	void		SetTopAmpl(int ampl);
	void		SetDecLevel(int level);
	void		SetDecScale(int scale);
	void		SetRepeat(int repeat);

	void		SetPanDelay(int delay);
	void		SetPanTopLevel(int level);
	void		SetPanTopAmpl(int ampl);
	void		SetPanDecLevel(int level);
	void		SetPanDecScale(int scale);
	void		SetPanRepeat(int repeat);

	void		SetExtIODialog(int set);
	void		SetExternView(int set);

	void		SetSamples(int mode, int set=1); 
	BOOL		GetColor(int reqID);
	void		UpdateStatus();
	void		DrawDrmImage();

typedef struct	{
				CWnd*	win;
				RECT	rect;
				}WINPOSION;
typedef CArray<WINPOSION,WINPOSION&> WinList;

	WinList		myWinList;
	CRect		myViewRect;
	void		Adjust(CRect &rect,int set);


	IQRecordCtrl	m_Rec;

	friend class MyPanoramaCtrl;
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(IFScopeControl)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
//	virtual BOOL PreTranslateMessage(MSG* pMsg);
	//}}AFX_VIRTUAL

// Implementation
protected:

	//dummys
	virtual void OnCancel(){}
	virtual void OnOK(){}

	friend class CRJ10FiFiDlg;

	CToolTipCtrl	m_tooltip;
	// Generated message map functions
	//{{AFX_MSG(IFScopeControl)
	virtual BOOL OnInitDialog();
	afx_msg void OnIfTopOff();
	afx_msg void OnIfstyleLin();
	afx_msg void OnIfstyleTopLin();
	afx_msg void OnIfstyleTopTsv();
	afx_msg void OnIfstyleTsv();
	afx_msg void OnExpandWindow();
	afx_msg void OnDesign1();
	afx_msg void OnDesign2();
	afx_msg void OnDesign3();
	afx_msg void OnSet48();
	afx_msg void OnSet96();
	afx_msg void OnSet192();

	afx_msg void OnSetTopDEC();
	afx_msg void OnSetTopTSV();
	afx_msg void OnSetLarge();
	afx_msg void OnSetSmall();
	afx_msg void OnDCcorrection();

	afx_msg void OnChangeColor();
	afx_msg void OnViewPamorama();
	afx_msg void OnSelchangeCombo1();
	afx_msg void OnAbout();
	afx_msg void OnDestroy();
	afx_msg void OnShowExtDialog();
	//}}AFX_MSG
	afx_msg LRESULT OnPotiChange(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnRButtonClick(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT StartAction(WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_IFSCOPECONTROL_H__46CC71E4_4EDA_4600_8F34_A0E8DF0E1968__INCLUDED_)
