// IQRecordCtrl.cpp : implementation file
//

#include "stdafx.h"
#include "GlobalTools.h"
#include "IQRecordCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// IQRecordCtrl dialog


IQRecordCtrl::IQRecordCtrl(CWnd* pParent /*=NULL*/)
	: CDialog(IQRecordCtrl::IDD, pParent)
{
	//{{AFX_DATA_INIT(IQRecordCtrl)
	m_slider = 0;
	//}}AFX_DATA_INIT
	IQhaltplay=IQhaltrecord=IQplayloop=0;
	IQrecord=IQplay=-1;
	maxpos=0;
}


void IQRecordCtrl::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(IQRecordCtrl)
	DDX_Control(pDX, IDC_PLAY_LOOP,		b_loop);
	DDX_Control(pDX, IDC_PLAY_WAVE,		b_play);
	DDX_Control(pDX, IDC_HALT_WAVE,		b_halt);
	DDX_Control(pDX, IDC_RECORD,		b_record);
	DDX_Control(pDX, IDC_HALT_REC,		b_haltrec);							
	DDX_Control(pDX, IDC_REC_SCROLL,	m_Hscrol);
	DDX_Control(pDX, IDC_LIST_WAVE,		m_List);
	DDX_Control(pDX, IDC_REC_PNTR,		s_recpntr);
	//}}AFX_DATA_MAP
}										
										
										
BEGIN_MESSAGE_MAP(IQRecordCtrl, CDialog)
	//{{AFX_MSG_MAP(IQRecordCtrl)		
	ON_BN_CLICKED(IDC_PLAY_WAVE,		OnPlayWave)
	ON_BN_CLICKED(IDC_HALT_REC,			OnHaltRec)
	ON_BN_CLICKED(IDC_RECORD,			OnRecord)
	ON_BN_CLICKED(IDC_PLAY_LOOP,		OnPlayLoop)
	ON_BN_CLICKED(IDC_HALT_WAVE,		OnHaltPlay)
	ON_WM_HSCROLL()
	//}}AFX_MSG_MAP						
	ON_MESSAGE(WM_WAVEFILE_DBLCLKB,		OnDblclkIQList)
	ON_MESSAGE(WM_WAVEFILE_CHANGED,		OnItemchangedIQList)
	ON_MESSAGE(WM_IF_FILE_WRITE,		OnRecordWrite)
	ON_MESSAGE(WM_IF_FILE_READ,			OnPlayRead)
	ON_MESSAGE(WM_IF_FILE_CLOSE,		OnPlayClose)
	ON_MESSAGE(WM_IF_FILE_REWIND,		OnPlayRewind)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// IQRecordCtrl message handlers

BOOL IQRecordCtrl::OnInitDialog() 
{
	CDialog::OnInitDialog();

	b_play.SetImage(IDB_PLAY);
	b_record.SetImage(IDB_REC);
	b_loop.SetImage(IDB_LOOP);

	m_Hscrol.SetRange(0,100);
	m_Hscrol.SetTicFreq(10);

	s_recpntr.SetFont(&fixFont);
	m_List.Init();
	StateStopRecord();
	StateStopPlay();
	m_List.SelectItem(1);
	m_List.Invalidate();
	m_List.RedrawWindow();

	return TRUE;               
}

void IQRecordCtrl::OnCancel() {}  //CANCEL and OK we do not use
void IQRecordCtrl::OnOK() {}
void IQRecordCtrl::OnPlayWave() 
{	
	PlayWave();
}

void IQRecordCtrl::OnHaltRec() 
{
	HaltRec();
}

void IQRecordCtrl::OnRecord() 
{
	if(IQrecord>=0) StateStopRecord();
	else StateStartRecord();
}

void IQRecordCtrl::OnPlayLoop() 
{
	if(!IQplayloop) IQplayloop=1;
	else IQplayloop=0;
	IQ_LoopPlay(IQplayloop);
	b_loop.SetCheck(IQplayloop);
	if(IQplayloop) b_loop.SetImage(IDB_LOOP1);
	else b_loop.SetImage(IDB_LOOP);
}

void IQRecordCtrl::OnHaltPlay() 
{
	HaltWave();
}

LRESULT IQRecordCtrl::OnDblclkIQList(WPARAM wParam, LPARAM lParam) 
{
	if(IQplay<0) 
		{
		StateStartPlay();
		}
	else
		{
		StateStopPlay();
		SetNewItem();
		StateStartPlay();
		}
	return NULL;
}

LRESULT IQRecordCtrl::OnItemchangedIQList(WPARAM wParam, LPARAM lParam) 
{
	if(IQplay<0) SetNewItem();
	return NULL;
}

LRESULT IQRecordCtrl::OnRecordWrite(WPARAM wParam, LPARAM lParam) 
{
	SetPointer(wParam);
	return NULL;
}

LRESULT IQRecordCtrl::OnPlayRead(WPARAM wParam, LPARAM lParam) 
{
	SetPointer(wParam);
	m_Hscrol.SetPos(wParam);
	CTime tim=IQtime+lParam;
	//sprintf(myIFView.m_ClockText,"%s",tim.Format("%H:%M:%S %d.%b.%Y"));
	return NULL;
}

LRESULT IQRecordCtrl::OnPlayClose(WPARAM wParam, LPARAM lParam) 
{
	StateStopPlay();
	return NULL;
}

LRESULT IQRecordCtrl::OnPlayRewind(WPARAM wParam, LPARAM lParam) 
{
	SetPointer(0);
	m_Hscrol.SetPos(0);
	return NULL;
}

void IQRecordCtrl::SeekSliderPos(int pos) 
{
	if(pos==-1) pos=m_Hscrol.GetPos();
	SetPointer(pos);
	m_Hscrol.SetPos(pos);
	IQ_SeekSetPlayFile(pos);
}

void IQRecordCtrl::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	 if (pScrollBar->m_hWnd==m_Hscrol.m_hWnd)
		{
		 int pos=pos=m_Hscrol.GetPos();
		
		switch(nSBCode)
			{
			case	SB_LEFT:		//Scroll to far left.
					pos=(pos/1000)*1000;
					pos-=1000; 
					break;

			case	SB_ENDSCROLL:	//End scroll.
					return;

			case	SB_LINELEFT:	//Scroll left.
					pos=(pos/1000)*1000;
					pos-=1000;
					break;

			case	SB_LINERIGHT:	//Scroll right.
					pos=(pos/1000)*1000;
					pos+=1000;
					break;

			case	SB_PAGELEFT:	//Scroll one page left.
					pos=(pos/10000)*10000;
					pos-=10000;
					break;

			case	SB_PAGERIGHT:	//Scroll one page right.
					pos=(pos/10000)*10000;
					pos+=10000;
					break;

			case	SB_RIGHT:		//Scroll to far right.
					pos=(pos/1000)*1000;
					pos-=1000;
					break;

			case	SB_THUMBPOSITION: //Scroll to absolute position. The current position is specified by the nPos parameter.
					return;

			case	SB_THUMBTRACK:	// Drag scroll box to specified position. The current position is specified by the nPos parameter. 
					break;
			}
	
		if(pos<0) pos=0;
		if(pos>maxpos) pos=maxpos;
		SeekSliderPos(pos);
		}
}

void IQRecordCtrl::SetPointer(int set) 
{
	char buf[256];
	double m=(double)set/1000000;
	double g=(double)set/1000000000;

	if(set>1000000000) sprintf(buf,"%.6f GByte ",g);
	else if(set>1000000) sprintf(buf,"%.6f MByte ",m);
	else sprintf(buf,"%d Byte ",set);

	s_recpntr.SetWindowText(buf);
}


//*****************************************
//* Record Routines ***********************
//*****************************************
void IQRecordCtrl::HaltRec() 
{
	if(IQrecord>=0) SetStateHaltRec(IQhaltrecord^1);

}
void IQRecordCtrl::SetStateHaltRec(int state) 
{
	IQhaltrecord=state;
	b_haltrec.SetCheck(state);
	if(b_haltrec.IsWindowEnabled())
		{
		if(state) b_haltrec.SetImage(IDB_HALT1);
		else b_haltrec.SetImage(IDB_HALT);
		}
	else b_haltrec.SetImage(IDB_HALT2);
	IQ_HaltRec(state);
}

void IQRecordCtrl::SetStateRecRec(int state) 
{
	IQrecord=state;
	if(state>=0) 
		{
		b_record.SetCheck(1);
		b_record.SetImage(IDB_REC1);
		}
	else 
		{
		b_record.SetCheck(0);
		b_record.SetImage(IDB_REC);
		}
}

void IQRecordCtrl::StateStopRecord()
{
	CloseRecord();
	SetStateRecRec(-1);
	SetStateHaltRec(0);
	b_haltrec.EnableWindow(FALSE);
	b_haltrec.SetImage(IDB_HALT2);
	SeekSliderPos(0);
}

void IQRecordCtrl::StateStartRecord()
{
	CloseRecord();
	SeekSliderPos(0);
	char buf[256];
	CTime savetime(time(0));
	UINT frq=myMainFrm->m_frq;
	UINT type=0;

	switch(myMainFrm->m_mode)
		{
		case REC_LSB:	type|=RECORD_LSB; break;
		case REC_USB:	type|=RECORD_USB; break;
		case REC_CW:	type|=RECORD_CW; break;
		case REC_FM:	type|=RECORD_FM; break;
		case REC_WFM:	type|=RECORD_WFM; break;
		case REC_DRM:	type|=RECORD_DRM; break;
		case REC_AMSS:	type|=RECORD_AMS; break;
		default:
		case REC_AM:	type=RECORD_AM; break;
		}
	sprintf(buf,"%s\\AUDIO\\RADIO_%04d-%02d-%02d_%02d-%02d_IQ%02X%08X.RIF",
	myDIR,
	savetime.GetYear(),
	savetime.GetMonth(),
	savetime.GetDay(),
	savetime.GetHour(),
	savetime.GetMinute(),type,frq);

	if(!IQ_Record(buf,m_hWnd))	return;
	
	b_haltrec.EnableWindow(TRUE);
	SetStateHaltRec(0);
	SetStateRecRec(0);
}
void IQRecordCtrl::CloseRecord() 
{
	if(IQrecord>=0) 
		{
		IQ_StopRecord();
		m_List.MakeNewList();
		}
}

//***************************************
//* Play Routines ***********************
//***************************************

void IQRecordCtrl::SetNewItem() 
{
	char filename[256];
	if(!m_List.GetLastFileName(filename)) return; 

	WAVEFORMATEX fmt={0};

	maxpos=IQ_GetPlayFileInfo(filename,&fmt);
	m_Hscrol.SetRange(0,maxpos);
	m_Hscrol.SetTicFreq(maxpos/10);
	IQtime=m_List.lastFileTime;
	if(!maxpos) lastIFfile.Empty();
	else
		{
		lastIFfile=filename;
		SetPointer(maxpos);
		m_Hscrol.SetPos(0);
		}

	if(lastIFfile.IsEmpty())
		{
		b_play.EnableWindow(FALSE);
		b_play.SetImage(IDB_PLAY2);
		}
	else 
		{
		b_play.EnableWindow(TRUE);
		b_play.SetImage(IDB_PLAY);
		}
}

BOOL IQRecordCtrl::PlayOpen(char *buf) 
{
	ClosePlay();

	IQtime=m_List.lastFileTime;

	char *t=strstr(buf,"_IQ");
	if(!t) {IQPlayFRQ=7000000; IQPlayMODE=0;}
	else
		{
		UINT frq=14000000;
		UINT type=0;
		IQPlayMODE=0;

		sscanf(t,"_IQ%02X%08X",&type,&frq);
		switch(type)
			{
			case RECORD_LSB:	IQPlayMODE=REC_LSB; break;
			case RECORD_USB:	IQPlayMODE=REC_USB; break;
			case RECORD_CW:		IQPlayMODE=REC_CW;  break;
			case RECORD_FM:		IQPlayMODE=REC_FM; break;
			case RECORD_WFM:	IQPlayMODE=REC_WFM; break;
			case RECORD_DRM:	IQPlayMODE=REC_DRM;  break;
			case RECORD_AMS:	IQPlayMODE=REC_AMSS;  break;
			default:
			case RECORD_AM:		IQPlayMODE=REC_AM;  break;
			}
		IQPlayFRQ=frq;
		}
	if(!IQ_Play(buf,m_hWnd,IQplayloop)) return 1;
	IQplay=0;
	return 0;
}

//RADIO_2011-08-21_04-25_IQ20003C5938.RIF

void IQRecordCtrl::ClosePlay() 
{
	IQ_StopPlay();
	IQplay=-1;
	SeekSliderPos(0);
//***	myRadioPage->UnLookPlayMode();
}

void IQRecordCtrl::HaltWave() 
{
	if(IQplay>=0) SetStateHaltWave(IQhaltplay^1);
}

void IQRecordCtrl::PlayWave() 
{
	if(IQplay>=0) StateStopPlay();
	else StateStartPlay();
}

void IQRecordCtrl::StateStopPlay()
{
	ClosePlay();
	SetStatePlayWave(-1); 
	SetNewItem();
}

void IQRecordCtrl::StateStartPlay()
{
	char	buf[256];
	if(m_List.GetLastFileName(buf))
		{
		IQplay=-1;
		int pos=m_Hscrol.GetPos();
		if(PlayOpen(buf)) return;
		IQplaylen=IQ_GetPlayFileLenght();
		SetStatePlayWave(IQplay);
		SeekSliderPos(pos);
//***		myRadioPage->LookPlayMode(IQPlayFRQ,IQPlayMODE);
		}
}
void IQRecordCtrl::SetStatePlayWave(int state) 
{
	IQplay=state;
	if(state>=0) 
		{
		b_play.SetCheck(1);
		b_play.SetImage(IDB_PLAY1);
		b_halt.EnableWindow(TRUE);
		b_halt.SetImage(IDB_HALT);
		}
	else 
		{
		b_play.SetCheck(0);
		b_play.SetImage(IDB_PLAY);
		b_halt.EnableWindow(FALSE);
		b_halt.SetImage(IDB_HALT2);
		SeekSliderPos(maxpos);
		}
	SetStateHaltWave(0); 
}

void IQRecordCtrl::SetStateHaltWave(int state) 
{
	IQhaltplay=state;
	IQ_HaltPlay(state);
	b_halt.SetCheck(state);

	if(b_halt.IsWindowEnabled())
		{
		if(state) b_halt.SetImage(IDB_HALT1);
		else b_halt.SetImage(IDB_HALT);
		}
	else b_halt.SetImage(IDB_HALT2);
}	
