#if !defined(IQ_RECORD_CTRL)
#define IQ_RECORD_CTRL

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// IQRecordCtrl.h : header file
//

#include "MyClasses/IQFileList.h"

/////////////////////////////////////////////////////////////////////////////
// IQRecordCtrl dialog

class IQRecordCtrl : public CDialog
{
// Construction
public:
	IQRecordCtrl(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(IQRecordCtrl)
	enum { IDD = IDD_IQ_RECORDER };
	MyButton		b_loop;
	MyButton		b_play;
	MyButton		b_halt;
	MyButton		b_record;
	MyButton		b_haltrec;
	CSliderCtrl		m_Hscrol;
	IQFileList		m_List;
	CStatic			s_recpntr;
	int		m_slider;
	//}}AFX_DATA
	
	MyButton		b_HoldOnRec;

	int				maxpos;
	time_t			IQtime;					//the record time or file time
	int				IQplay;					//pointer for play
	int				IQrecord;				//pointer for record 
	int				IQhaltplay;				//pointer for halt
	int				IQhaltrecord;			//pointer for halt
	int				IQplaylen;				//Play data len
	int				IQplayloop;				//if playloop==1 reopen the IF-WaveFile to loop IF-Input

	int				IQPlayFRQ;
	int				IQPlayMODE;
	CString			lastIFfile;
	void			SeekSliderPos(int pos);
	void			SetPointer(int set);

	void			PlayWave();
	void			StatePlaywave();
	void			PlayLoop();
	void			SethPos(int pos); 
	void			StateStartRecord();
	void			StateStopRecord();
	void			CloseRecord(); 
	void 			ClosePlay();
	BOOL			PlayOpen(char *buf);
	void			SetStateHaltRec(int state);
	void			SetStateHaltWave(int state); 
	void			SetStateRecRec(int state);
					
	void			HaltRec();
	void			HaltWave();
	void			StateStartPlay();
	void			SetStatePlayWave(int state);
	void			SetNewItem();
	void			StateStopPlay();


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(IQRecordCtrl)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(IQRecordCtrl)
	virtual BOOL OnInitDialog();
	afx_msg void OnPlayWave();
	afx_msg void OnHaltRec();
	afx_msg void OnPlayLoop();
	afx_msg void OnHaltPlay();
	afx_msg void OnRecord();
	virtual void OnCancel();
	virtual void OnOK();
	//}}AFX_MSG
	afx_msg LRESULT OnDblclkIQList(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnItemchangedIQList(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnRecordWrite(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnPlayRead(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnPlaySeek(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnPlayClose(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnPlayRewind(WPARAM wParam, LPARAM lParam);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg LRESULT OnGroupBoxRefresh(WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(IQ_RECORD_CTRL)
