// FileList.cpp : implementation file
//

#include "stdafx.h"
#include "../GlobalTools.h"
#include "IQFileList.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// IQFileList
IMPLEMENT_DYNCREATE(IQFileList, CListCtrl)
IQFileList::IQFileList()
{
	maxitems=flag=init=m_cxClient=0;
	lastitem=-1;
	mMsgWin=NULL;
}

IQFileList::~IQFileList()
{
}


BEGIN_MESSAGE_MAP(IQFileList, CListCtrl)
	//{{AFX_MSG_MAP(IQFileList)
	ON_WM_CONTEXTMENU()
	ON_WM_ERASEBKGND()
	ON_NOTIFY_REFLECT(LVN_KEYDOWN,		OnKeydown)
	ON_COMMAND(IDR_IQ_FILEREQ_CD,		OnWavFilereqCd)
	ON_COMMAND(IDR_IQ_FILEREQ_DELETE,	OnWavFilereqDelete)
	ON_COMMAND(IDR_IQ_FILEREQ_RENAME,	OnWavFilereqRename)
	ON_COMMAND(IDR_IQ_FILEREQ_RF,		OnWavFilereqRf)
	ON_NOTIFY_REFLECT(NM_DBLCLK,		Dblclk)
	ON_NOTIFY_REFLECT(LVN_ITEMCHANGED,	Itemchanged)
	ON_WM_MOUSEMOVE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// IQFileList message handlers

void IQFileList::InitWaveDir(char *di, char *m_ext, int m_flag)
{
	strcpy(dir,di);
	_strupr(dir);
	strcpy(ext,m_ext);
	_strupr(ext);
	flag=m_flag;
	mMsgWin = GetParent();
	if(init) return;
	
	ListView_SetExtendedListViewStyle(m_hWnd,LVS_EX_FULLROWSELECT);

	CRect re;
	GetClientRect(&re);

	LV_COLUMN	lvc;
	lvc.mask = LVCF_FMT | LVCF_WIDTH;
	lvc.fmt = LVCFMT_RIGHT;
	lvc.cx = re.Width()-20;
	InsertColumn(0,&lvc);

	m_tooltip.Create(this);
	m_tooltip.AddTool(this);
	m_tooltip.Activate(TRUE);
	memset(&seletedRIFItem,0,sizeof(RIFFILELIST));

	SetFont(&fixFont);
	init=1;
}

void IQFileList::Init()
{
	char di[256];
	sprintf(di,"%s\\AUDIO",myDIR);
	InitWaveDir(di,"RIF",1);

	CRect myRect;
	GetClientRect(myRect);
	m_cxClient = myRect.Width();

	MakeNewList();
	Invalidate();
	RedrawWindow();
}

void IQFileList::OnContextMenu(CWnd*, CPoint point)
{
	CMenu menu;
	if (menu.LoadMenu(IDR_IQ_FILEREQ))
		{
        CMenu* pPopup = menu.GetSubMenu(0);
        ASSERT(pPopup != NULL);
        pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON,point.x, point.y, this); // use main window for cmds
		}
}

void IQFileList::SortList()
{
	int			i,s=1;
	RIFFILELIST	sfl1,sfl2;

	if(maxitems<2) return;
		
	while(s)
		{
		for(i=0, s=0; i<maxitems-1; i++)
			{
			if(strcmp(filelist[i+1].shortname,filelist[i].shortname)<0)
				{
				sfl1=filelist.GetAt(i+1);
				sfl2=filelist.GetAt(i);
				filelist.SetAt(i,sfl1);
				filelist.SetAt(i+1,sfl2);
				s=1;
				}
			}
		}
}
void IQFileList::MakeNewList()
{
	LV_ITEM		lvi;
	int			i;

	if(!init) return;
	DeleteAllItems();
	GetNewList();
	SortList();

	lastitem=-1;
	for(i=0; i<maxitems; i++)
		{
		lvi.mask		= LVIF_TEXT;
		lvi.pszText		= filelist[i].shortname;
		lvi.iItem		= i;
		lvi.iSubItem	= 0;
		InsertItem(&lvi);
		if(strcmp(lastfilename,filelist[i].shortname)==0) lastitem=i; 
		}

	SelectItem(lastitem);	
}

void IQFileList::GetNewList()
{
	CFileFind		finder;
	BOOL			bWorking;
	RIFFILELIST		fl;
	CTime			tam;
	WAVEFORMATEX	fmt={0};

	lastitem=-1;
	maxitems=0;

	sprintf(fl.filename,"%s\\*.%s",dir,ext);
	bWorking = finder.FindFile(fl.filename);
	filelist.RemoveAll();
	while (bWorking)
		{
		bWorking = finder.FindNextFile();
		if(finder.IsDots()) continue;
		memset(&fl,0,sizeof(RIFFILELIST));
		strcpy(fl.filename,finder.GetFilePath().GetBuffer(255));
		if(ext[0]=='*' && fl.shortname[strlen(fl.shortname)-1]=='M') continue;
		if(fl.fileLenght=IQ_GetPlayFileInfo(fl.filename,&fmt))
			{
			fl.nChannels=fmt.nChannels;
			if(fl.nChannels==2)	strcat(fl.shortname," 2 Channels");
			}
	
		time_t t=MakeFileName(fl.filename,fl.shortname,&fl);
		if(t==-1) continue; 
		if(t) fl.fileTime=t;
		else 
			{
			finder.GetLastWriteTime(tam);
			fl.fileTime=tam.GetTime();
			double sampleByteTime=(1./(double)fmt.nSamplesPerSec)/(double)fmt.nBlockAlign;
			fl.fileTime-=time_t( (double)fl.fileLenght*sampleByteTime+.5);
			}

		filelist.Add(fl);
		maxitems++;
		}
	finder.Close();
	SortList();
}

time_t IQFileList::MakeFileName(char *filename, char *newname,RIFFILELIST *fl)
{
	//012345678901234567890
	//1997-10-15_08-09.EXT
	//=971015 08:09
	char name[256];
	char buf[256];
	char shortname[65];
	char hz[16],mod[4];;
	char *oldname;
	int	 i,workflag=0,len,m=0;
	time_t ret=0;
	double IQPlayFRQ,f;
	UINT frq=14000000;
	UINT type=0;
	UINT mode=0;

	_strupr(filename);
	strcpy(buf,filename);
	strcpy(name,buf);
	name[47]=0;
	shortname[0]=workflag=0;

	for(i=(int)strlen(buf)-1; i>0; i--)
		{
		if(buf[i]=='\\')
			{
			strcpy(name,&buf[i+1]);
			name[47]=0;
			break;
			}
		}

	for(i=(int)strlen(name)-1; i>0; i--)
		{
		if(name[i]=='.')
			{
			name[i]=0;
			break;
			}
		}

	if(name[0]=='R' && name[1]=='A' && name[2]=='D' && name[3]=='I' && name[4]=='O' && name[5]=='_')
		{
		m=6; 
		}
	else
		{
		workflag=1;
		}

	oldname=&name[m];


	mode=REC_AM; 
	mod[0]='A'; mod[1]='M'; 
	mod[2]=mod[3]=0;

	char *t=strstr(oldname,"_IQ");
	if(!t) 
		{
		if(m==6) 
			{
			t=strstr(oldname,"_IF");
			if(t) return -1;
			}
		IQPlayFRQ=7000.0;
		strncpy(shortname,name,32);
		shortname[32]=0;
		}
	else
		{
		if(workflag)
			{
			len=strlen(name)-strlen(t);
			if(len>63) len=63;
			for(i=0; i<len; i++)
				{
				shortname[i]=name[i];
				}
			shortname[i]=0;
			}

		sscanf(t,"_IQ%02X%08X",&type,&frq);
		type&=RECORD_MODEMASK;
		switch(type&RECORD_MODEMASK)
			{
			case RECORD_LSB: mode=REC_LSB; mod[0]='L'; mod[1]='S'; mod[2]='B'; break;
			case RECORD_USB: mode=REC_USB; mod[0]='U'; mod[1]='S'; mod[2]='B'; break;
			case RECORD_CW:  mode=REC_CW;  mod[0]='C'; mod[1]='W'; break;
			default:
			case RECORD_AM: mode=REC_AM; mod[0]='A'; mod[1]='M'; break;
			case RECORD_FM: mode=REC_FM; mod[0]='F'; mod[1]='M'; break;
			case RECORD_WFM: mode=REC_WFM; mod[0]='W'; mod[1]='F'; mod[2]='M'; break;
			case RECORD_DRM: mode=REC_DRM; mod[0]='D'; mod[1]='R'; mod[2]='M'; break;
			case RECORD_AMS: mode=REC_AMSS; mod[0]='A'; mod[1]='M'; mod[2]='S'; break;
			}
		//type&=RECORD_TYPEMASK;
		IQPlayFRQ=(double)frq/1000.;
		*t=0;
		}

	//          1         2
	//012345678901234567890123456789
	//123456789_2006-04-27_06-32.RIF

	hz[1]='H'; 
	hz[2]='z'; 
	hz[3]=0; 
	
	if(IQPlayFRQ>30000.) {f=IQPlayFRQ/1000; hz[0]='M';} 
	else {f=IQPlayFRQ;hz[0]='k';} 

	if(oldname[4]=='-' && oldname[7]=='-' && oldname[10]=='_' && oldname[13]=='-')
		{
		sprintf(newname,"%c%c%c%c%c%c %c%c:%c%c %.3f %s %s",
		 	oldname[2],oldname[3],
			oldname[5],oldname[6],
			oldname[8],oldname[9],
			oldname[11],oldname[12],
			oldname[14],oldname[15],f,hz,mod);

		oldname[4]=oldname[7]=oldname[10]=oldname[13]=oldname[16]=0;
		int year=atoi(oldname);
		int month=atoi(&oldname[5]);
		int day=atoi(&oldname[8]);
		int hour=atoi(&oldname[11]);
		int min=atoi(&oldname[14]);

		if(month>=1 && month<=12 && day>=1 && day<=31 && hour>=0 && hour<=23 && min>=0 && min<=59)
			{
			CTime tim(year,month,day,hour,min,0);
			ret=tim.GetTime();
			}
		}
	else
		{
		sprintf(newname,"%s %.3f %s",name,f,hz);
		}

	if(fl)
		{
		fl->frq=IQPlayFRQ;
		fl->mode=mode;
		fl->type=type;
		fl->workflag=workflag;
		if(workflag) strcpy(fl->shortname,shortname);
		else fl->shortname[0]=0;
		fl->modename[0]=mod[0];
		fl->modename[1]=mod[1];
		fl->modename[2]=mod[2];
		fl->modename[3]=mod[3];
		}
	return ret;

}

void IQFileList::OnKeydown(NMHDR* pNMHDR, LRESULT* pResult) 
{
	LV_KEYDOWN* pLVKeyDow = (LV_KEYDOWN*)pNMHDR;
	*pResult = 0;
	if(lastitem<0) return;

	switch(pLVKeyDow->wVKey)
		{
		case VK_DELETE: DeleteFile(lastitem); break;
		case VK_RETURN: break;
		}
}
BOOL IQFileList::GetLastFileName(char *name) 
{
	if(lastitem<0 || lastitem>maxitems) return FALSE;
	strcpy(name,filelist[lastitem].filename);
	return TRUE;
}
void IQFileList::DeleteFile(int item) 
{
	if(item<0 || item>maxitems) return;
	char	buf[256];

	strcpy(buf,filelist[item].filename);
	
	//CloseIFInput(0);
	//myRadio.IFinput.Close();

	if(!remove(buf))
		{
		filelist.RemoveAt(item);
		maxitems--;
		lastfilename[0]=0;
		if(lastitem>maxitems-1) lastitem=maxitems-1;
		if(lastitem>=0)
			{
			strcpy(lastfilename,filelist[lastitem].shortname);
			}
		MakeNewList();
		}
}

void IQFileList::Dblclk(NMHDR* pNMHDR, LRESULT* pResult) 
{
	*pResult = 0;
	GetParent()->SendMessage(WM_WAVEFILE_DBLCLKB,GetDlgCtrlID(),(LPARAM)pNMHDR);
}

void IQFileList::Itemchanged(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	*pResult = 1;
	if(!init) return;
	*pResult = 0;
	
	lastitem=pNMListView->iItem;
	lastfilename[0]=0;
	if(lastitem<0) return;

	char	buf[256];
	strcpy(buf,filelist[lastitem].filename);
	lastFileTime=filelist[lastitem].fileTime;
	MakeFileName(buf, lastfilename);
	memcpy(&seletedRIFItem,&filelist[lastitem],sizeof(RIFFILELIST));
	GetParent()->SendMessage(WM_WAVEFILE_CHANGED,GetDlgCtrlID(),(LPARAM)pNMHDR);
}

void IQFileList::SelectItem(int sel)
{
	lastfilename[0]=0;
	if(!maxitems) {lastitem=-1; return;}
	else
		{
		if(sel>=maxitems || sel<0) sel=0;
		}
	SetItemState(sel, LVIS_SELECTED|LVIS_FOCUSED|LVIS_ACTIVATING,LVIS_SELECTED|LVIS_FOCUSED|LVIS_ACTIVATING);
	EnsureVisible(sel,1);
	SetSelectionMark(sel);
	lastitem=sel;

	char	buf[256];
	strcpy(buf,filelist[sel].filename);
	MakeFileName(buf, lastfilename);
}

void IQFileList::OnWavFilereqCd() 
{
	lastitem=-1;
	ChangeDir();		
}

void IQFileList::ChangeDir()
{
	char	buf[256];
	char	DefExt[256];
	char	Filter[256];

	strcpy(DefExt,"*.rif");
	strcpy(Filter,"RIF RadioIF Files (*.rif)|*.rif|");
	sprintf(buf,"%s",dir);

	CFileDialog fdlg(TRUE, DefExt, DefExt,OFN_EXTENSIONDIFFERENT|OFN_SHAREAWARE|OFN_HIDEREADONLY|OFN_NOVALIDATE,Filter);

	fdlg.m_ofn.lpstrTitle = "Change the IF/File Directory";
	fdlg.m_ofn.lpstrInitialDir =buf;

	if(fdlg.DoModal()==IDOK)
		{
		strcpy(buf,fdlg.GetPathName());
		for(int i=(int)strlen(buf); i>0; i--)
			{
			if(buf[i]=='\\') 
				{
				buf[i]=0; 
				strcpy(dir,buf);
				InitWaveDir(dir,"RIF",1);
				break;
				}
			}
		MakeNewList();
		}
}
void IQFileList::OnWavFilereqDelete() 
{
	if(GetSelectionMark() !=lastitem) return;
	DeleteFile(lastitem); 
	OnWavFilereqRf();
}

#include "../RenameDlg.h"
void IQFileList::OnWavFilereqRename() 
{
	char	buf[256];
	if(GetLastFileName(buf))
		{
		CRenameDlg dlg(this,buf);
		if(dlg.DoModal()==IDOK) 
			{
			MakeNewList();
			}
		}
}

void IQFileList::OnWavFilereqRf() 
{
	MakeNewList();
}

void IQFileList::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct) 
{
	int nItem = lpDrawItemStruct->itemID;
	if(nItem<0 || nItem>=filelist.GetSize()) return;
	CDC* pDC = CDC::FromHandle(lpDrawItemStruct->hDC);
	CRect rcItem(lpDrawItemStruct->rcItem);
	m_clrTextBk=GetSysColor(COLOR_WINDOW);

	BOOL bFocus = (GetFocus() == this);
	COLORREF clrTextSave, clrBkSave;
//	char        szBuff[MAX_PATH];

// get item data

	LV_ITEM lvi;
	lvi.mask = LVIF_IMAGE | LVIF_STATE;
	lvi.iItem = nItem;
	lvi.iSubItem = 0;
	lvi.stateMask = 0xFFFF;     // get all state flags
	GetItem(&lvi);

	BOOL bSelected = (bFocus || (GetStyle() & LVS_SHOWSELALWAYS)) && lvi.state & LVIS_SELECTED;
	bSelected = bSelected || (lvi.state & LVIS_DROPHILITED);

// set colors if item is selected

	CRect rcAllLabels;
	GetItemRect(nItem, rcAllLabels, LVIR_BOUNDS);

	CRect rcLabel,all;
	GetItemRect(nItem, rcLabel, LVIR_LABEL);


	rcAllLabels.left = rcItem.left;
	//if (rcAllLabels.right<m_cxClient)	rcAllLabels.right = m_cxClient;

	if (bSelected)
		{
		clrTextSave = pDC->SetTextColor(GetSysColor(COLOR_HIGHLIGHTTEXT));
		clrBkSave = pDC->SetBkColor(GetSysColor(COLOR_HIGHLIGHT));
		pDC->FillRect(rcAllLabels, &CBrush(GetSysColor(COLOR_HIGHLIGHT)));
		}
	else
		{
		clrTextSave = pDC->SetTextColor(GetSysColor(COLOR_WINDOWTEXT));
		clrBkSave = pDC->SetBkColor(m_clrTextBk);
		pDC->FillRect(rcAllLabels, &CBrush(m_clrTextBk));
		}

	CTime	tim(filelist[nItem].fileTime);
	GetItemRect(nItem, rcItem, LVIR_LABEL);
	int		dr,i;
	char	*textbuf,szBuff[256];

	rcItem.right=0;

	for( i = 0; i<4; i++)
		{
		rcItem.left = rcItem.right;
		
		if(filelist[nItem].workflag && i<2)
			{
			if(i) continue;
			rcItem.right=rcItem.left+156;
			sprintf(szBuff,"   %s",filelist[nItem].shortname);
			textbuf=szBuff;				
			dr=DT_LEFT|DT_END_ELLIPSIS;
			}
		else switch(i)
			{
			case  0: //Time
					sprintf(szBuff,"%s",tim.FormatGmt("%H:%M"));
					textbuf=szBuff;		
					dr=DT_RIGHT;
					rcItem.right=rcItem.left+40;
					break;
			case  1://Date
					sprintf(szBuff,"%s",tim.FormatGmt("%d.%b.%Y"));
					textbuf=szBuff;	
					dr=DT_LEFT;
					rcItem.left+=20;
					rcItem.right=rcItem.left+96;
					break;
			case  2://Frequency //
					sprintf(szBuff,"%8.3f KHz",filelist[nItem].frq);
					rcItem.right=rcItem.left+86;
					textbuf=szBuff;	
					dr=DT_RIGHT;
					break;
		
			case  3://Mode
					dr=DT_LEFT;
					rcItem.left-=20;
					rcItem.right=rcItem.left+=30;
					switch(filelist[nItem].type)
						{
						case RECORD_LSB: textbuf="LSB"; break;
						case RECORD_USB: textbuf="USB"; break;
						case RECORD_CW:  textbuf="CW"; break;
						case RECORD_FM:  textbuf="FM"; break;
						case RECORD_WFM: textbuf="WFM"; break;
						case RECORD_DRM:  textbuf="DRM"; break;
						case RECORD_AMS:  textbuf="AMS"; break;

						default:
						case RECORD_AM:  textbuf="AM"; break;
						}
					break;

			}
		pDC->DrawText(textbuf,-1, rcItem, dr | DT_SINGLELINE | DT_NOPREFIX | DT_NOCLIP | DT_VCENTER);
		}

// draw focus rectangle if item has focus

	if (lvi.state & LVIS_FOCUSED && bFocus)
		pDC->DrawFocusRect(rcAllLabels);

// set original colors if item was selected
	pDC->SetTextColor(clrTextSave);
	pDC->SetBkColor(clrBkSave);
}

void IQFileList::OnMouseMove(UINT nFlags, CPoint point) 
{
	CRect		re;
	int			nItem;

	if(m_tooltip.m_hWnd)
		{
		if ((nItem = HitTest(point)) != -1) 
			{
			GetItemRect(nItem,re, LVIR_BOUNDS);
			if(re.PtInRect (point)) 
				{
				//ifOKsetFocus(m_hWnd);
				m_tooltip.UpdateTipText(filelist[nItem].shortname,this);
				}
			else m_tooltip.Pop();
			}
		}

	CListCtrl::OnMouseMove(nFlags, point);
}

BOOL IQFileList::PreTranslateMessage(MSG* pMsg) 
{
	if(pMsg->message ==WM_MOUSEMOVE)
		{
		if(m_tooltip.m_hWnd) m_tooltip.RelayEvent(pMsg);
		}	
	return CListCtrl::PreTranslateMessage(pMsg);
}
