// MyButton.cpp : implementation file
//
////////////////////////////////////////////////////
////////////////////////////////////////////////////
// !!! this is not public domain !!!
// You can do what you want if it never hurt bonito.
// Otherwise, you will need the consent of Bonito.	
////////////////////////////////////////////////////
// RadioJet Open Source Project RJ10Mini
// www.bonito.net/radiojet/opensource
////////////////////////////////////////////////////
////////////////////////////////////////////////////

#include "stdafx.h"
#include "../GlobalTools.h"
#include "MyButton.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// MyButton

IMPLEMENT_DYNCREATE(MyButton, CButton)
MyButton::MyButton()
{
	m_hMenu				= NULL;
	m_menu				= 0;
	m_state				= 0;
	m_bold				= 0;
	dir					= DT_CENTER;
	TextColor			= -1;
	m_bMenuInAction		= FALSE;
	m_bPushed			= FALSE;
	m_bHighlighted		= FALSE;
	m_bCaptured			= FALSE;
	m_bRighImage		= FALSE;
	m_bButtonStyle		= 0;
	m_noBorder			= 0;
	imgSize.cx=imgSize.cy=0;
	CheckPos=m_nMenuResult=-1;
}

MyButton::~MyButton()
{
}

BEGIN_MESSAGE_MAP(MyButton, CButton)
	//{{AFX_MSG_MAP(MyButton)
	ON_WM_PAINT()
	ON_WM_ERASEBKGND()
	ON_WM_CREATE()
	ON_WM_SETCURSOR()
	ON_WM_RBUTTONDOWN()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_KILLFOCUS()
	ON_WM_MOUSEMOVE()
	ON_WM_ENABLE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// MyButton message handlers

void MyButton::PreSubclassWindow() 
{
	ModifyStyle (BS_DEFPUSHBUTTON, BS_OWNERDRAW);
	if(GetStyle()&BS_FLAT) m_bButtonStyle=1;
	CButton::PreSubclassWindow();
}

BOOL MyButton::PreCreateWindow(CREATESTRUCT& cs) 
{
	cs.style |= BS_OWNERDRAW;
	cs.style &= ~BS_DEFPUSHBUTTON;
	if(cs.style&BS_FLAT) m_bButtonStyle=1;
	return CButton::PreCreateWindow(cs);
}

BOOL MyButton::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	dwStyle |= BS_OWNERDRAW;
	dwStyle &= ~BS_DEFPUSHBUTTON;
	if(dwStyle&BS_FLAT) m_bButtonStyle=1;
	return CWnd::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

int MyButton::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	lpCreateStruct->style |= BS_OWNERDRAW;
	lpCreateStruct->style &= ~BS_DEFPUSHBUTTON;

	if(lpCreateStruct->style&BS_FLAT) m_bButtonStyle=1;
	if (CButton::OnCreate(lpCreateStruct) == -1) return -1;
	return 0;
}

void MyButton::DrawItem(LPDRAWITEMSTRUCT di) {}
void MyButton::OnPaint() 
{
	//flicker subpression

	CPaintDC	pdc(this);
	CDC			dc;
	CRect		rect;
	CBitmap		bitmap;
	CBitmap*	pOldBitmap;

	GetClientRect(rect);

	//draw in bitmap - subpress the flicker
	if (dc.CreateCompatibleDC(&pdc))
		{
		if (bitmap.CreateCompatibleBitmap(&pdc,rect.Width(), rect.Height()))
			{
			pOldBitmap = dc.SelectObject(&bitmap);
			}
		}

	OnDraw(&dc,rect);
	pdc.BitBlt(rect.left,rect.top,rect.Width(),rect.Height(),&dc, 0, 0, SRCCOPY);
	dc.SelectObject(pOldBitmap);
}

void MyButton::OnDraw(CDC* pDC,CRect rect) 
{
	CRect		rx,ri=rect,re=rect;
	CString		strText;
	CFont		*OldFont; 
	COLORREF	cltTextOld,col; 

	int			BkModeOld=pDC->SetBkMode(TRANSPARENT);
	POINT		pt;

	GetWindowText(strText);
	if(m_menu || m_hMenu) re.right-=10;
	if(imgSize.cx)
		{

		if (!strText.IsEmpty() && m_bRighImage!=3)
			{
			if (m_bRighImage) // Right  image: / m_bRighImage=1
				{
				ri.right = re.right-5;
				ri.left = ri.right-imgSize.cx;
				re.right = ri.left;
				}
			else // Left   image: / m_bRighImage=0
				{
				re.left += imgSize.cx+5;
				ri.left += 5;
				ri.right = ri.left+imgSize.cx;
				}
			}
		else
			{

			}

		// Center image: / m_bRighImage=3
		ri.DeflateRect ((ri.Width () - imgSize.cx) / 2, max (0,(rect.Height () - imgSize.cy) / 2));
		pt.x=ri.left; pt.y=ri.top;
		}

	if(m_bold==2) OldFont= pDC->SelectObject(&BigFont);
	else if(m_bold==1 || (m_bButtonStyle && (m_state || m_bPushed || m_bHighlighted))) OldFont= pDC->SelectObject(&fontBold);
	else OldFont=pDC->SelectObject(&fontRegular);

	if(TextColor==-1) col=COL_BTXT;
	else col=TextColor;
	cltTextOld = pDC->SetTextColor(col);

	FillBackground(pDC,rect);
	if(imgSize.cx) m_img.Draw(pDC,0,pt,ILD_NORMAL);
	if(m_bButtonStyle==1) //BS_FLAT?
		{
		if(m_noBorder==2 && m_state) pDC->Draw3dRect (rect,myVDARK,myVLIGHT);
		else if(!m_noBorder) DrawStyleRect(pDC,rect,myVDARK);
		}
	else
		{
		if(!m_noBorder) DrawStyleRect(pDC,rect,myVLIGHT);
		}
	if(m_state && TextColor==-1 && m_bButtonStyle!=1) cltTextOld = pDC->SetTextColor(RGB(255,255,255));
	else cltTextOld = pDC->SetTextColor(TextColor);


	re.DeflateRect(1,1);

	if(!IsWindowEnabled())
		{
		rx=re;
		pDC->SetTextColor (myVLIGHT);
		rx.OffsetRect (1, 1);
		pDC->DrawText (strText, rx, DT_SINGLELINE|DT_VCENTER|DT_CENTER|DT_NOPREFIX|DT_END_ELLIPSIS);
		pDC->SetTextColor (myVDARK);
		}

	if(GetStyle( )&BS_MULTILINE) 
		{
		rx=re;
		pDC->DrawText(strText, rx, DT_CALCRECT);
		int h=(re.Height()-(rx.Height()*2))/2;
		re.top+=h-1; re.bottom-=h;
		pDC->DrawText(strText, re, DT_CENTER|DT_WORDBREAK|DT_NOPREFIX);

		}
	else pDC->DrawText(strText, re, DT_SINGLELINE|DT_VCENTER|DT_CENTER|DT_NOPREFIX|DT_END_ELLIPSIS);

	
	if(m_menu||m_hMenu)
		{
		CPen	xpen(PS_SOLID,1,col);
		CPen	Vpen(PS_SOLID,1,myVLIGHT);
		CPen	Dpen(PS_SOLID,1,myDARK);
		CRect	rb=rect;

		HPEN	pOldPen;
		HBRUSH	pOldBrush; 
		
		CBrush	brush(col);
		CBrush	Dbrush(myDARK);
		
		if (!IsWindowEnabled())
			{
			pOldPen=(HPEN)::SelectObject(pDC->m_hDC,Dpen);
			pOldBrush= (HBRUSH)::SelectObject(pDC->m_hDC,Dbrush);
			}
		else 
			{
			pOldPen=(HPEN)::SelectObject(pDC->m_hDC,xpen);
			pOldBrush= (HBRUSH)::SelectObject(pDC->m_hDC,brush);
			}
		
		rb.left=rect.right-16;
		
		CPoint c=rb.CenterPoint();
		c.y-=3; 
		c.x-=5;
		POINT pt[3];
		pt[0].x = c.x; 
		pt[0].y = c.y+1;
		
		pt[1].x = (c.x+3);
		pt[1].y = c.y+4;
		
		pt[2].x = c.x+6;
		pt[2].y = c.y+1;
		
		
		pDC->Polygon(pt, 3);
		if (!IsWindowEnabled())
			{
			pDC->SelectObject(&Vpen);
			pDC->MoveTo(pt[1].x+1,pt[1].y);
			pDC->LineTo(pt[2].x+1,pt[2].y);
			}

		::SelectObject(pDC->m_hDC,pOldBrush);
		::SelectObject(pDC->m_hDC,pOldPen);
		}

	pDC->SetTextColor(cltTextOld);
	pDC->SetBkMode(BkModeOld);
	pDC->SelectObject(OldFont);
}

void MyButton::SetCheck(int state, BOOL bRedraw)
{
	if(m_state==state) return;

	m_state=state;
	CButton::SetCheck(m_state);
	if (bRedraw && GetSafeHwnd() != NULL)
		{
		RedrawWindow();
		}
}

void MyButton::SetColor(COLORREF col, int bold, BOOL bRedraw)
{
	TextColor=col;
	m_bold=bold;
	if (bRedraw && GetSafeHwnd() != NULL)
		{
		RedrawWindow();
		}
}

void MyButton::SetBold(int bold, BOOL bRedraw)
{
	m_bold=bold;
	if (bRedraw && GetSafeHwnd() != NULL)
		{
		RedrawWindow();
		}
}

void MyButton::SetStyle(int style, BOOL bRedraw)
{
	m_bButtonStyle=style;
	if (bRedraw && GetSafeHwnd() != NULL)
		{
		RedrawWindow();
		}
}

void MyButton::SetImage(UINT ID,int rightImage)
{
	// Center image: / m_bRighImage=3
	// Left   image: / m_bRighImage=0
	// Right  image: / m_bRighImage=1
	m_bRighImage=rightImage;
	if(ID)
		{
		HBITMAP hbm=(HBITMAP) ::LoadImage (AfxGetResourceHandle (),MAKEINTRESOURCE (ID),IMAGE_BITMAP,0, 0,LR_CREATEDIBSECTION | LR_LOADMAP3DCOLORS);
		SetImage (hbm);
		::DeleteObject (hbm);
		}
	else
		{
		m_img.DeleteImageList();
		imgSize.cx=imgSize.cy=0;
		}
	RedrawWindow();
}

void MyButton::SetImage (HBITMAP hbm)
{
	m_img.DeleteImageList();
	
	BITMAP bmp;
	::GetObject (hbm, sizeof (BITMAP), (LPVOID) &bmp);
	imgSize.cx = bmp.bmWidth;
	imgSize.cy = bmp.bmHeight;

	UINT nFlags = ILC_MASK;

	switch (bmp.bmBitsPixel)
		{
		case 4:
		default:
			nFlags |= ILC_COLOR4;
			break;

		case 8:
			nFlags |= ILC_COLOR8;
			break;

		case 16:
			nFlags |= ILC_COLOR16;
			break;

		case 24:
			nFlags |= ILC_COLOR24;
			break;

		case 32:
			nFlags |= ILC_COLOR32;
			break;
		}

	m_img.Create (bmp.bmWidth, bmp.bmHeight, nFlags, 0, 0);
	HBITMAP copyBitMap = (HBITMAP) ::CopyImage (hbm, IMAGE_BITMAP, 0, 0, 0);
	m_img.Add (CBitmap::FromHandle (copyBitMap), RGB(255,0,255));  // the background must always be purple
	::DeleteObject (copyBitMap);
}

BOOL MyButton::OnEraseBkgnd(CDC* pDC) 
{
	return TRUE;
}

BOOL MyButton::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	if (m_Hand != NULL)
		{
		CRect rectClient;
		GetClientRect (rectClient);

		CPoint ptCursor;
		::GetCursorPos (&ptCursor);
		ScreenToClient (&ptCursor);

		if (rectClient.PtInRect (ptCursor))
			{
			::SetCursor (m_Hand);
			return TRUE;
			}
		}
	
	return CButton::OnSetCursor(pWnd, nHitTest, message);
}

#define BTN_DARK	myDARK
#define BTN_LIGHT	myLIGHT
#define BTN_VLIGHT	myVLIGHT
#define BTN_VDARK	myVDARK

void MyButton::DrawBitmap(HDC hDC, int x, int y, HBITMAP hBitmap)
{
   HDC		hdc;     
   POINT	stPoint;  
   BITMAP	stBitmap;
   HGDIOBJ	hObject;

   // create a compatible device context in memory and select the bitmap
   // in to it.

   if (!(hdc = CreateCompatibleDC(hDC))) return;

   hObject = SelectObject(hdc, hBitmap);
   SetMapMode(hdc, GetMapMode(hDC));

   // Get bitmap size and convert it to logical units from device units.

   GetObject(hBitmap, sizeof(BITMAP), &stBitmap);
   stPoint.x = stBitmap.bmWidth;
   stPoint.y = stBitmap.bmHeight;
   DPtoLP(hDC, &stPoint, 1);

   // bit block transfer the bitmap from memory device context to given
   // device context at specified location

   BitBlt(hDC, x, y, stPoint.x, stPoint.y, hdc, 0, 0, SRCCOPY);

   // select original object in the memory device context and destroy it

   SelectObject(hdc, hObject);
   DeleteDC(hdc);
}

void MyButton::FillBackground (CDC* pDC, const CRect& re)
{
	COLORREF col1,col2;
	CRect rectClient=re;

	if(m_bButtonStyle==1)
		{
		if((m_bHighlighted|m_bPushed) && m_state) 
			{
			col1=COL_BACK;
			}
		else if(m_bHighlighted|m_bPushed|m_state) col1=AddBasisColor(COL_BACK,-.07); //light back color
		else col1=COL_BACK;
		pDC->FillRect (rectClient, &CBrush(col1)); 
		return;
		}

	rectClient.DeflateRect(1,1); 
	if (m_state && !(m_bPushed && m_bHighlighted))
		{
		if(m_bButtonStyle==2)  
			{
			if(m_bHighlighted||m_bPushed) {col1=BTN_DARK; col2=BTN_LIGHT;} 
			else {col1=BTN_LIGHT; col2=BTN_DARK;}
			}
		else if(!m_bHighlighted) {col1=BTN_DARK; col2=BTN_VDARK;} 
		else {col2=BTN_DARK; col1=BTN_VDARK;} 
		}
	else
		{
		if(m_bButtonStyle==2 && m_state) 
			{
			if ((m_bPushed || m_bHighlighted)) {col1=BTN_LIGHT; col2=BTN_DARK;}
			else {col2=BTN_LIGHT; col1=BTN_DARK;}
			}
		else
			{
			if (m_bHighlighted) {col1=BTN_LIGHT; col2=BTN_DARK;}
			else {col2=BTN_LIGHT; col1=BTN_DARK;}
			}	
		}

	FillGradient(pDC,rectClient,AddBasisColor(col1,.05),AddBasisColor(col2,.05)); 
}

void MyButton::SetMenu(UINT menu)
{
	m_menu=menu;
}

void MyButton::SetMenu(HMENU menu)
{
	m_hMenu=menu;
}


void MyButton::CheckMenuItem(int pos, char *txt)
{
	CheckPos=pos;
	if(txt)
		{
		SetWindowText(txt);
		RedrawWindow();
		}
}

void MyButton::OnShowMenu () 
{
	CWnd* pParent = GetParent ();
	if (!(m_menu || m_hMenu) || m_bMenuInAction || !pParent) return;

	m_bMenuInAction = TRUE;

	CRect rectWindow;
	GetWindowRect (rectWindow);

	int x, y;

	x = rectWindow.left;
	y = rectWindow.bottom;

	RedrawWindow();

	if (m_bCaptured)
		{
		ReleaseCapture ();
		m_bCaptured = FALSE;
		}

	CMenu menu;
	CMenu* pPopup=NULL;
	if(!m_hMenu)
		{
		menu.LoadMenu(m_menu);
		pPopup = menu.GetSubMenu(0);
		}
	else
		{
		pPopup=CMenu::FromHandle(m_hMenu);
		}

	if(pPopup)
		{
		if(CheckPos!=-1)
			{
			int i,items=pPopup->GetMenuItemCount(); 
			for(i=0; i<items; i++) 
				{
				if(i!=CheckPos) 
					{
					pPopup->CheckMenuItem(i,MF_BYPOSITION|MF_UNCHECKED);
					}
				else 
					{
					pPopup->CheckMenuItem(i,MF_BYPOSITION|MF_CHECKED);
					}
				}
			}

		m_nMenuResult =pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RETURNCMD, x, y,pParent);
		if (m_nMenuResult != 0)
			{
			CWnd* pParent = GetParent ();
			if (pParent != NULL)
				{
				pParent->SendMessage (WM_COMMAND,MAKEWPARAM (GetDlgCtrlID (), BN_CLICKED),(LPARAM) m_hWnd);
				}
			}
		}

	m_bPushed = FALSE;
	m_bHighlighted = FALSE;
	m_bMenuInAction = FALSE;
	
	RedrawWindow();

	if (m_bCaptured)
		{
		ReleaseCapture ();
		m_bCaptured = FALSE;
		}
}

void MyButton::OnLButtonDown(UINT nFlags, CPoint point) 
{
	if (m_menu) OnShowMenu ();
	else 
		{
		CButton::OnLButtonDown(nFlags, point);
		CWnd* pParent = GetParent ();
		if (pParent != NULL)
			{
			pParent->SendMessage (WM_COMMAND,MAKEWPARAM (GetDlgCtrlID (), BN_CLICKED),(LPARAM) m_hWnd);
			}
		}
	RedrawWindow();
}

void MyButton::OnLButtonUp(UINT nFlags, CPoint point) 
{
	m_bPushed = FALSE;
	m_bHighlighted = FALSE;
	m_bPushed = FALSE;
	if (m_bCaptured)
		{
		ReleaseCapture ();
		m_bCaptured = FALSE;
		}

	CButton::OnLButtonUp(nFlags, point);
	RedrawWindow();
}

void MyButton::OnRButtonDown(UINT nFlags, CPoint point) 
{
	CWnd* pParent = GetParent ();
	if (pParent != NULL) pParent->SendMessage (WM_RBCLICK,GetDlgCtrlID (),0);
	CButton::OnRButtonDown(nFlags, point);
}

void MyButton::OnKillFocus(CWnd* pNewWnd) 
{
	CButton::OnKillFocus(pNewWnd);
	if (m_bCaptured)
		{
		ReleaseCapture ();
		m_bCaptured = FALSE;
		}

	m_bPushed = FALSE;
	m_bHighlighted = FALSE;
	RedrawWindow();
}

void MyButton::OnMouseMove(UINT nFlags, CPoint point) 
{
	BOOL bRedraw = FALSE;

	CRect rectClient;
	GetClientRect (rectClient);

	if (rectClient.PtInRect (point))
		{
		if (!m_bHighlighted)
			{
			m_bHighlighted = TRUE;
			bRedraw = TRUE;
			}

		if ((nFlags & MK_LBUTTON) && !m_bPushed)
			{
			m_bPushed = TRUE;
			bRedraw = TRUE;
			}

		if (!m_bCaptured)
			{
			SetCapture ();
			m_bCaptured = TRUE;
			bRedraw = TRUE;
			}
		}
	else
		{
		if (nFlags & MK_LBUTTON)
			{
			if (m_bPushed)
				{
				m_bPushed = FALSE;
				bRedraw = TRUE;
				}
			}
		else if (m_bHighlighted)
			{
			m_bHighlighted = FALSE;
			bRedraw = TRUE;
			}

		if (m_bCaptured && (!nFlags & MK_LBUTTON))
			{
			ReleaseCapture ();
			m_bCaptured = FALSE;

			bRedraw = TRUE;
			}
		}

	if (bRedraw)
		{
		RedrawWindow();
		}
	
	CButton::OnMouseMove(nFlags, point);
}

int MyButton::GetXsizeOfContent()
{
	ASSERT (GetSafeHwnd () != NULL);

	CClientDC dc (this);

	CFont* pOldFont = dc.SelectObject (&fontBold);
	ASSERT(pOldFont != NULL);

	CString strText;
	GetWindowText (strText);
	CSize sizeText = dc.GetTextExtent (strText);
	dc.SelectObject (pOldFont);
	return sizeText.cx+=6;
}

int MyButton::SetXsizeOfContent(int x,int y,int cy,int off)
{
	int cx=GetXsizeOfContent();
	SetWindowPos(NULL,x,y,cx+off,cy,SWP_NOZORDER|SWP_NOOWNERZORDER|SWP_NOACTIVATE);
	return x+cx+off;
}

void MyButton::OnEnable(BOOL bEnable) 
{
	CButton::OnEnable(bEnable);
	RedrawWindow();
}

BOOL MyButton::PreTranslateMessage(MSG* pMsg) 
{
	if (m_tooltip.GetSafeHwnd () != NULL)
		{
		if (pMsg->message == WM_LBUTTONDOWN ||
			pMsg->message == WM_LBUTTONUP ||
			pMsg->message == WM_MOUSEMOVE)
			{
			m_tooltip.RelayEvent(pMsg);
			}
		}	
	return CButton::PreTranslateMessage(pMsg);
}

void MyButton::SetTooltip (UINT tttID)
{
	CString str;
	str.LoadString(tttID);
	SetTooltip (str.GetBuffer(0));
}

void MyButton::SetTooltip (char *ttt)
{
	if (ttt == NULL)
		{
		if (m_tooltip.GetSafeHwnd () != NULL)
			{
			m_tooltip.Activate (FALSE);
			}
		}
	else
		{
		if (m_tooltip.GetSafeHwnd () != NULL)
			{
			m_tooltip.UpdateTipText (ttt, this);
			}
		else
			{
			m_tooltip.Create (this, TTS_ALWAYSTIP);
			m_tooltip.AddTool (this, ttt);
			}
		m_tooltip.Activate (TRUE);
		}
}
