// MyIFView.cpp : implementation file
//
////////////////////////////////////////////////////
////////////////////////////////////////////////////
// !!! this is not public domain !!!
// You can do what you want if it never hurt bonito.
// Otherwise, you will need the consent of Bonito.	
////////////////////////////////////////////////////
// RadioJet Open Source Project RJ10FiFi
// www.bonito.net/radiojet/opensource
////////////////////////////////////////////////////
////////////////////////////////////////////////////

#include "stdafx.h"
#include "../GlobalTools.h"
#include "MyIFView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

HCURSOR WINAPI ::SetCursor(HCURSOR cur);

/////////////////////////////////////////////////////////////////////////////
// MyIFView

IMPLEMENT_DYNCREATE(MyIFView, CButton)

MyIFView::MyIFView()
{
	myStatus[0]=m_frqtxt[0]=m_dBtxt[0]=0;

	init=m_frqdelay=m_spow=m_ssiz=m_sfrq=m_xs=m_ys=x_zoom=m_frqlo=m_st=
	lastPOS=INVALidate=m_bCaptured=moveflag=m_viewLO=m_viewHI=m_OutCntr=0;
	m_Off=1;
	m_fftscal=m_posscal=0;
	pt=db=db2=0;
	m_fscal=2;
	topLevel=topAmpl=topBright=m_ampl=m_level=m_bright=0;
	o_hi=o_lo=-1;
	force=0;
	noSmoothing=1;
	DraftMode=-1;
	dB0Offset=4;
	memset(&GetPara,0,sizeof(IF_DRAW_PARA));
	dBmV=.020*pow(10,-73.*.05);
	top_ySnap=0;  
	dbScale=dbLevel=0;
}

MyIFView::~MyIFView()
{
	Exit(); 
}

BEGIN_MESSAGE_MAP(MyIFView, CButton)
	//{{AFX_MSG_MAP(MyIFView)
	ON_WM_ERASEBKGND()
	ON_WM_PAINT()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_SETCURSOR()
	ON_WM_MOUSEWHEEL()
	ON_WM_CREATE()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//****************************************************************************
void MyIFView::PreSubclassWindow() 
{
	ModifyStyle (BS_DEFPUSHBUTTON, BS_OWNERDRAW);
	CButton::PreSubclassWindow();
}

//****************************************************************************
BOOL MyIFView::PreCreateWindow(CREATESTRUCT& cs) 
{
	cs.style |= BS_OWNERDRAW;
	cs.style &= ~BS_DEFPUSHBUTTON;

	return CButton::PreCreateWindow(cs);
}

BOOL MyIFView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	dwStyle |= BS_OWNERDRAW;
	dwStyle &= ~BS_DEFPUSHBUTTON;
	
	return CWnd::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

int MyIFView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	lpCreateStruct->style |= BS_OWNERDRAW;
	lpCreateStruct->style &= ~BS_DEFPUSHBUTTON;

	if (CButton::OnCreate(lpCreateStruct) == -1) return -1;
	
	// TODO: Add your specialized creation code here
	
	return 0;
}

void MyIFView::Exit()
{
	if(m_fftscal)	delete []m_fftscal; m_fftscal = 0;
	if(m_posscal)	delete []m_posscal; m_posscal = 0;
	if(pt)			delete []pt;		pt = 0;
	if(db)			delete []db;		db = 0;
	if(db2)			delete []db2;		db2 = 0;

}
void MyIFView::DrawItem(LPDRAWITEMSTRUCT lpDIS) {};

BOOL MyIFView::Init()
{
	m_frqhi=m_viewHI=myIFStyle.m_hi; 
	m_frqlo=m_viewLO=myIFStyle.m_lo;
	m_sfrq=IF_SAMPLE_FRQ; 
	m_ssiz=IF_SAMPLE_NUM;
	m_Off=m_OutCntr=0;

	if(myIFStyle.m_style!=IF_STYLE_TIV) myIFStyle.m_style=IF_STYLE_DEC;

	InitSpectrum(m_sfrq,m_ssiz,&myIFStyle);
	return TRUE;
}

void MyIFView::SetDelay(int delay) 
{
	if(delay>99) delay=99;
	m_SmothA=.5f+(float)delay*0.00505050505050505050505050505051f;
	m_SmothB=1.f-m_SmothA;
	if(!delay) noSmoothing=1;
	else noSmoothing=0;
}

BOOL MyIFView::InitSpectrum(int sample_frq, int sample_num,IF_ANA_STYLE *style)
{
	int		i,set=0;

	if(style) memcpy(&myIFStyle,style,sizeof(IF_ANA_STYLE));
	if(!init || sample_frq!=m_sfrq || sample_num!=m_ssiz)
		{
		Exit();
		m_sfrq = sample_frq; 
		m_ssiz = sample_num; 
		m_scale=m_sfrq >>1; 
		m_center=m_sfrq >>2;

		m_spow=0; for(i=m_ssiz;;) {if(!(i>>=1)) break; ++m_spow;}
		fnum = m_ssiz >> 1;
 		set=3;
		}   

	if(!myIFStyle.m_hi) {myIFStyle.m_lo=0; myIFStyle.m_hi = myIFStyle.m_hi;}

	if(!ReSizeSpectrum(set)) return FALSE;
	return TRUE;
}

void MyIFView::OnSize(UINT nType, int cx, int cy) 
{
	CButton::OnSize(nType, cx, cy);
	if(init)
		{
		ReSizeSpectrum(1);
		}
}

BOOL MyIFView::CheckSize()
{
	CRect winre,fftre,topview,topscale,scalerect;
	GetClientRect(winre);
	int ret=0;
	if(!init) ret=1;

	if(myIFStyle.topYPos<45) myIFStyle.topYPos=45;
	if(myIFStyle.topYPos>240) myIFStyle.topYPos=240;

	init=0;
	top_ys=myIFStyle.topYPos; t_ys=top_ys-12;

	if(myIFStyle.topOFF) toptop=0;
	else toptop=top_ys;


	fftre.left=fftre.top=topscale.left=topview.left=topview.top=0; 
	fftre.right=topscale.right=topview.right=winre.right; 
	topview.bottom=t_ys;

	topscale.top=topview.bottom; 
	topscale.bottom=topscale.top+12;
	fftre.bottom=winre.bottom-toptop-12;

	scalerect.top=winre.bottom-12;	
	scalerect.bottom=scalerect.top+12;
	scalerect.left=fftre.left; 
	scalerect.right=fftre.right;

	if(winre!=m_winre) {m_winre=winre; ret=1;}; 
	if(topview!=myTopViewRect) {myTopViewRect=topview; ret=1;}; 
	if(topscale!=myTopScale) {myTopScale=topscale; ret=1;};
	if(fftre!=m_fftre) {m_fftre=fftre; ret=1;};
	if(scalerect!=myScaleRect) {myScaleRect=scalerect; ret=1;};

	return ret;
}

void MyIFView::ClearView()
{
	if(init) 
		{	
		ClearTimeSpect();
		SetFftScale();
		memset(&GetPara,0,sizeof(IF_DRAW_PARA));
		int i;
		for(i=0; i<m_xs; i++) 
			{
			db2[i].x=db[i].x=pt[i].x=i; 
			db2[i].y=db[i].y=m_ys; 
			pt[i].y=t_ys;
			}
		db2[i].x=db[i].x=i-1; 
		db2[i+1].x=db[i+1].x=0; 
		db2[i].y=db[i].y=db2[i+1].y=db[i+1].y=m_ys; 
		RefreschWindow(2);
		}
}

BOOL MyIFView::ReSizeSpectrum(int set)
{
	if(CheckSize())
		{
		m_xs = m_fftre.Width(); 
		m_ys = m_fftre.Height(); 
	
		m_fftrgn.DeleteObject();
		m_fftrgn.CreateRectRgn(0,0,m_xs,m_ys);
		my_Width=(double)m_xs;
		my_Hight=(float)m_ys;
	
		TxTrect.top=m_fftre.top+toptop+2; 
		TxTrect.bottom=12; 
		TxTrect.left=m_fftre.left+8; 
		TxTrect.right=m_fftre.right-8;
		ClearTimeSpect();
		set|=1;
		}
	
	myIFStyle.m_lo=(myIFPara.m_lo/10)*10;
	myIFStyle.m_hi=(myIFPara.m_hi/10)*10;

	frqWidth=(double)(myIFStyle.m_hi-myIFStyle.m_lo)/1000.;
	frqStep=frqWidth/my_Width;
	frqLO=(double)myIFStyle.m_lo/1000;

	if(myIFStyle.m_hi > m_sfrq>>1 || myIFStyle.m_hi<=myIFStyle.m_lo) myIFStyle.m_hi = m_sfrq>>1; 
	if(myIFStyle.m_lo >= myIFStyle.m_hi) myIFStyle.m_lo = 0;
	
	if(myIFStyle.m_lo!=o_lo || myIFStyle.m_hi!=o_hi)
		{
		set|=2;
		o_lo=myIFStyle.m_lo;
		o_hi=myIFStyle.m_hi;
		}
	SetMyScale(myIFStyle.m_radiofrq+myIFStyle.m_lo,myIFStyle.m_radiofrq+myIFStyle.m_hi);

	m_viewHI=myIFStyle.m_hi; m_viewLO=myIFStyle.m_lo;
	frange = myIFStyle.m_hi - myIFStyle.m_lo;
	isrange = int(myIFStyle.m_fftrangehi - myIFStyle.m_fftrangelo);
	if(DraftMode>=0) DraftMode=-1;

	centermark=CalcValueDouble(myIFStyle.m_centermark-myIFStyle.m_lo,m_xs,frange,0);
	IFcentermark=CalcValueDouble(myIFStyle.m_IFCenter-myIFStyle.m_lo,m_xs,frange,0);

	if(fnum*frange/(m_sfrq>>1) > m_xs) x_zoom=1;
	else x_zoom=0;

	m_fscal = ((float)m_ssiz/((float)m_xs*m_scale/frange));

	if(set || !m_fftscal)
		{
		if(m_fftscal)	{delete []m_fftscal; m_fftscal = 0;}
		if(m_posscal)	{delete []m_posscal; m_posscal = 0;}
		if(pt)			{delete []pt;		pt = 0;}
		if(db)			{delete []db;		db = 0;}
		if(db2)			{delete []db2;		db2 = 0;}
		if(!(m_fftscal	= new int[m_xs+2])) return FALSE;
		if(!(m_posscal	= new int[m_xs+2])) return FALSE;
		if(!(pt = new POINT[m_xs+2])) return FALSE;
		if(!(db = new POINT[m_xs+2])) return FALSE;
		if(!(db2 = new POINT[m_xs+2])) return FALSE;
		int i;
		for(i=0; i<m_xs; i++) 
			{
			db2[i].x=db[i].x=pt[i].x=i; 
			db2[i].y=db[i].y=m_ys; 
			pt[i].y=t_ys;
			}
		db2[i].x=db[i].x=i-1; 
		db2[i+1].x=db[i+1].x=0; 
		db2[i].y=db[i].y=db2[i+1].y=db[i+1].y=m_ys; 
		SetFftScale();
		}

	SetAmpl(myIFStyle.m_ampl);
	SetTAmpl(myIFStyle.topAmpl);
	SetTLevel(myIFStyle.topLevel);
	SetDecLevel(myIFStyle.m_DecLevel);
	SetDecScale(myIFStyle.m_DecScale);

	init=force=1;
	SetDelay(myIFStyle.m_smoothing); 
	RedrawWindow(NULL,NULL,RDW_INVALIDATE|RDW_UPDATENOW|RDW_NOERASE);
	return TRUE;
}

int MyIFView::CalcValueDouble(int m_val, int m_xs, int m_frange, int max)
{
	int val= (int)(double)(((double)m_val * (double)m_xs / (double)m_frange));
	return __max(__min(val,m_xs-1),max);
}

void MyIFView::ClearTimeSpect()
{
	//create top overview scope timespectrum image
	topTSpec.CreateBitmap(m_hWnd,myTopViewRect.Width(),myTopViewRect.Height(),myTimeSpectPal[0]);

	//create main scope timespectrum image
	myTSpec.CreateBitmap(m_hWnd,m_fftre.Width(),m_fftre.Height(),myTimeSpectPal[0]);
	if(centermark) 
		{
		myTSpec.SelectCompatibleDC();
		HPEN OldPen=(HPEN)::SelectObject(myTSpec.m_hdcScr,&scopePenCenter);
		::MoveToEx(myTSpec.m_hdcScr,m_fftre.left+centermark,m_fftre.top,0);
		::LineTo(myTSpec.m_hdcScr,m_fftre.left+centermark,m_fftre.bottom);
		::MoveToEx(myTSpec.m_hdcScr,m_fftre.left+centermark+1,m_fftre.top,0);
		::LineTo(myTSpec.m_hdcScr,m_fftre.left+centermark+1,m_fftre.bottom);
		::SelectObject(myTSpec.m_hdcScr,OldPen);
		myTSpec.DeleteCompatibleDC();
		}
}

void MyIFView::SetFftScale()
{
	int		MagSize,i;
	float	fd,len=(float)m_xs;
	float	hi=(float)myIFStyle.m_hi;
	float	lo=(float)myIFStyle.m_lo;
	float	fftFrq,frq=(float)(m_sfrq>>1);
	
	fd = ((hi - lo) / len);

	frange = myIFStyle.m_hi - myIFStyle.m_lo;

	m_viewLO=(myIFStyle.m_lo/10)*10;
	m_viewHI=(myIFStyle.m_hi/10)*10;

	isrange = int(myIFStyle.m_fftrangehi - myIFStyle.m_fftrangelo);
	MagSize=m_ssiz>>1;

	for(i=0; i<=m_xs; i++)
		{
		fftFrq= lo+i*fd+(fd/2.f); 

		m_fftscal[i] = (int)((fftFrq * len / frq) * MagSize / len);
		if(m_fftscal[i] >=MagSize)
			{
			m_fftscal[i]=MagSize-1;
			}
		}
	fd = (float)m_scale / len;
	for(i=0; i<=m_xs; i++)	
		{
		fftFrq= i*fd+(fd/2.f); 
		m_posscal[i] = (int)((fftFrq * len	/ frq) * MagSize / len);
		if(m_posscal[i] >=MagSize)
			{
			m_posscal[i]=MagSize-1;
			}
		}
}

void MyIFView::RefreschWindow(int bErase)
{
	if(init && INVALidate!=bErase) 
		{
		INVALidate=bErase;
		if(IsWindowVisible()) 
			{
			if(bErase==2) RedrawWindow(NULL,NULL,RDW_INVALIDATE|RDW_UPDATENOW|RDW_NOERASE);
			else Invalidate(bErase);
			}
		}
}

void MyIFView::SetStyle(int style) 
{
	myIFStyle.m_style=style;
	SetFftScale();
}
void MyIFView::SetTopStyle(int style) 
{
	myIFStyle.topStyle=style;
	SetFftScale();
}

BOOL MyIFView::OnEraseBkgnd(CDC* /*pDC*/) {return TRUE;}

void MyIFView::GetDrawData()
{
	int			x,y,mx=0;
	float		ldata,v,dB,data,*MagData,*MagData2,dBx;
	COLORREF	CenterColor=AddBasisColor(COL_SCOPE_LINE,-.20);
	HDC			dc;
	BYTE		*p,*cp;
	UINT		style=myIFStyle.m_style&IF_STYLE_MASK;

	if(!init || m_Off)  return;

	GetIFDrawData(&GetPara,-1); //get current channel
	if(!GetPara.MagData[0]) return;
	MagData = GetPara.MagData[0];
	MagData2 = GetPara.MagData[1];

	//if the GetPara-Status == NoAnaViewAction, then no view action
	if(GetPara.getPointer==-1) return; 

	y = m_ys;
	dB=(my_Hight*(float)dbScale)/16.f;
	dBx=.6f; //-154dBm
	float o=(160-(160/dbScale))+dbLevel*10;

	int	xx;
	for(x=0; x<m_xs; x++)
		{
		data=todB(MagData[m_fftscal[x]]); //convert magnitude to logarithmic dB value			
		if(m_fftscal[x]!=m_fftscal[x+1])
			{
			for(xx=m_fftscal[x]; xx<m_fftscal[x+1]; xx++)
				{
				ldata=todB(MagData[xx]); //convert magnitude to logarithmic dB value
				if(ldata>data) data=ldata;
				}
			}
		if(data<dBx) data=dBx;

		if(DraftMode==0 && noSmoothing==0)
			{
			db[x].y = (int)( (db[x].y*m_SmothA) +  ((y-(data+dbLevel)*dB))*m_SmothB); 
			}
		else
			{
			db[x].y = y - (int)((data+dbLevel)*dB); 
			}
		if(db[x].y<0) db[x].y=0;
		if(db[x].y>y) db[x].y=y;
		}

	//TimeSpectrum
	v= GetPara.RawMean*64;
	if(!v) v=1;
	if(!m_bright) v=256.f/v;
	else v=256.f/(v/m_bright);
	
	if(!(dc = myTSpec.SelectCompatibleDC())) return;
	::ScrollDC(dc,0,-1,&m_fftre,&m_fftre,0,0);
	myTSpec.DeleteCompatibleDC();

	y = m_ys-1;
	p = myTSpec.GetMapAdress(0,y);
	for(x=0; x<m_xs; x++) 
		{
		data=MagData[m_fftscal[x]];
		if(m_fftscal[x]!=m_fftscal[x+1])
			{
			for(xx=m_fftscal[x]; xx<m_fftscal[x+1]; xx++)
				{
				if(MagData[xx]>data) data=MagData[xx];
				}
			}
		if(x && (x==centermark)) 
			{
			p[2] = GetRValue(CenterColor); 
			p[1] = GetGValue(CenterColor); 
			p[0] = GetBValue(CenterColor);   
			}
		else 
			{
			mx=__min((int)(data*v),255); 
			cp = (BYTE*)&myTimeSpectPal[mx&0xFF];
			p[0] = cp[2]; 
			p[1] = cp[1]; 
			p[2] = cp[0];
			}
		p+=3;
		}
	MakeTopDraw();
	m_OutCntr++;
	if(DraftMode<0) DraftMode++;
	RefreschWindow();
}

void MyIFView::MakeTopDraw()
{
	int		x,y;
	float	v,max,data,*MagData=GetPara.MagData[0],dB;
	HDC		dc;
	BYTE	*p,*cp;
	int		mx=0;

	if(topAmpl) max=GetPara.MagMax*topAmpl;
	else max=GetPara.MagMax;
	if(!max) return;
	max=(float)(t_ys/2)/max;
	int	xx;

	//Top Line Spectrum View
	if(myIFStyle.topStyle&IF_STYLE_TOP_DEC)
		{
		if(topAmpl) dB=t_ys/1600.f/max;
		else dB=t_ys/10.f;
		y = t_ys; 
		for(x=0; x<m_xs; x++) 
			{
			data=todB(MagData[m_posscal[x]]);
			if(DraftMode==0 && noSmoothing==0)
				{
				pt[x].y =(int)( (pt[x].y*m_SmothA) +  ((y-(data+topLevel)*dB))*m_SmothB); 
				}
			else  pt[x].y = y - (int)((data+topLevel)*dB); 
			if(pt[x].y>t_ys) pt[x].y=t_ys;
			}
		}

	//TimeSpectrum
	v= GetPara.RawMean*64;
	if(!v) v=1;
	if(!topBright) v=256.f/v;
	else v=256.f/(v/topBright);
	
	if(!(dc = topTSpec.SelectCompatibleDC())) return;
	::ScrollDC(dc,0,-1,&myTopViewRect,&myTopViewRect,0,0);
	topTSpec.DeleteCompatibleDC();

	COLORREF CenterColor=AddBasisColor(COL_SCOPE_LINE,-.20);

	y = t_ys-1;
	p = topTSpec.GetMapAdress(x,y);
	for(x=0; x<m_xs; x++) 
		{
		data=MagData[m_posscal[x]];
		if(m_posscal[x]!=m_posscal[x+1])
			{
			for(xx=m_posscal[x]; xx<m_posscal[x+1]; xx++)
				{
				if(MagData[xx]>data) data=MagData[xx];
				}
			}
		mx=__min((int)(data*v),255); 
		cp = (BYTE*)&myTimeSpectPal[mx&0xFF];
		p[0] = cp[2]; 
		p[1] = cp[1]; 
		p[2] = cp[0];
		p+=3;
		}

}

void MyIFView::OnPaint() 
{
	CPaintDC pdc(this); // device context for painting
	if(init)
		{
		UINT		style=myIFStyle.m_style&IF_STYLE_MASK;

		if(ScopeBack.m_width!=m_winre.Width() || ScopeBack.m_height!=m_winre.Height())
			{
			ScopeBack.CreateBitmap(m_hWnd,m_winre.Width(),m_winre.Height(),myTimeSpectPal[0]);
			}

		ScopeBack.SelectCompatibleDC();
		if(init && !m_Off &IsWindowVisible())
			{
			if(style==IF_STYLE_TIV) DrawTimeSpec(ScopeBack.m_hdcScr);
			else DrawLines(ScopeBack.m_hdcScr);
			}
		DrawScale(ScopeBack.m_hdcScr,myScaleRect,m_frqlo,m_frqhi,m_st);
		if(!myIFStyle.topOFF) DrawTopLines(ScopeBack.m_hdcScr);
		if(!m_Off) UserDraw(ScopeBack.m_hdcScr);
		ScopeBack.DeleteCompatibleDC();
		ScopeBack.BitBlt(pdc.m_hDC,m_winre.left,m_winre.top,m_winre.Width(),m_winre.Height(), 0, 0, SRCCOPY);
		}

	INVALidate=0;
}

void MyIFView::OutTextString(HDC hdc, int xpos, int ypos, char *txt, UINT nFlags)
{
	UINT a=SetTextAlign(hdc,nFlags);

	::SetTextColor(hdc,COL_SCOPE_B); //draw first big outlines
	int len=strlen(txt);
	::TextOut(hdc,xpos-2,ypos-2,txt,len);
	::TextOut(hdc,xpos-1,ypos-2,txt,len);
	::TextOut(hdc,xpos+1,ypos-2,txt,len);
	::TextOut(hdc,xpos+2,ypos-2,txt,len);
	
	::TextOut(hdc,xpos-2,ypos-1,txt,len);
	::TextOut(hdc,xpos-1,ypos-1,txt,len);
	::TextOut(hdc,xpos+1,ypos-1,txt,len);
	::TextOut(hdc,xpos+2,ypos-1,txt,len);
	
	::TextOut(hdc,xpos-2,ypos+1,txt,len);
	::TextOut(hdc,xpos-1,ypos+1,txt,len);
	::TextOut(hdc,xpos+1,ypos+1,txt,len);
	::TextOut(hdc,xpos+2,ypos+1,txt,len);
	
	::TextOut(hdc,xpos-2,ypos+2,txt,len);
	::TextOut(hdc,xpos-1,ypos+2,txt,len);
	::TextOut(hdc,xpos+1,ypos+2,txt,len);
	::TextOut(hdc,xpos+2,ypos+2,txt,len);
	
	::SetTextColor(hdc,myIFStyle.m_TextColor);//now draw in the center of the outline area
	::TextOut(hdc,xpos, ypos,txt,len);
	SetTextAlign(hdc,a);
}

void MyIFView::UserDraw(HDC hdc)
{
	if(!myExtRxPara.IQ_onoff || !myExtRxPara.IQ_open || myStatus[0] || m_frqdelay > 0)
		{
		int		bk=::SetBkMode(hdc,TRANSPARENT); 
		int		tx=::SetTextColor(hdc,myIFStyle.m_TextColor);
		HFONT	ohf = (HFONT)::SelectObject(hdc,minifont);
		CRect	ra(TxTrect),re(TxTrect);
		UINT	dir=DT_RIGHT;

		if(!myExtRxPara.IQ_onoff || !myExtRxPara.IQ_open)
			{
			CString str;
			if(!myExtRxPara.IQ_onoff) str.LoadString(IDS_EXTIQ_NOT_ACTIVE);
			else str.LoadString(IDS_EXTIQ_NOT_OPEN);

			::SetTextColor(hdc,RGB(240,40,0)); //COL_RED;
			::SelectObject(hdc,BigDateFont);
			::DrawText (hdc,str,-1,m_fftre, DT_CENTER|DT_VCENTER|DT_SINGLELINE);
			}
		else if(m_frqdelay > 0) 
			{
			m_frqdelay--;
			OutTextString(hdc,TxTrect.right,TxTrect.top,m_frqtxt,TA_RIGHT);
			ra.bottom+=14; ra.top+=14;
			OutTextString(hdc,ra.right,ra.top,m_dBtxt,TA_RIGHT);
			}
		else if(myStatus[0])
			{
			SIZE	si;
			re.top=TxTrect.top+8;
			re.bottom=re.top+21;
			::SelectObject(hdc,fontBold);
			GetTextExtentPoint32(hdc,myStatus,strlen(myStatus),&si);
			re.left=centermark-((si.cx+12)/2);
			re.right=centermark+((si.cx+12)/2);
			HBRUSH hb = (HBRUSH)::SelectObject(hdc,scopelight);
			HPEN hp = (HPEN)::SelectObject(hdc,scopePenLine);
			::RoundRect(hdc,re.left,re.top+3,re.right,re.bottom,4,4);
			::SelectObject(hdc,hp);
			::SelectObject(hdc,hb);
			re.top+=1; re.bottom+=1;
			::DrawText (hdc,myStatus,-1,re, DT_CENTER|DT_VCENTER|DT_SINGLELINE);	
			}
		::SelectObject(hdc,ohf);
		tx=::SetTextColor(hdc,tx);
		bk=::SetBkMode(hdc,bk); 
		}
}

void MyIFView::DrawLines(HDC hdc)
	{
	HBRUSH	hb;
	HPEN	hp;
	char	txt[16];
	float	step,o=0;
	int		z,i,t,m=10,x,y,setBorder=0,scaleLo,scaleHi;
	UINT    style=myIFStyle.m_style&IF_STYLE_MASK;
	CRect	re;

	::SetViewportOrgEx(hdc,0,toptop,0); 

	hb = (HBRUSH)::SelectObject(hdc,ana_back);
	hp = (HPEN)::SelectObject(hdc,scopePenLine);
	if(myIFStyle.m_style&IF_STYLE_DEC)
		{
		FillScopeBack(hdc,m_fftre,COL_SCOPE_B,COL_SCOPE_B2);
		//::FillRect(hdc,&m_fftre,scopeback);
		::SelectObject(hdc,scopelight);
		}
	else
		{
		PatBlt(hdc,0,0,m_xs,m_ys,PATCOPY);
		::SelectObject(hdc,ana_range);
		}


	scaleLo=x = __max(__min((int)(myIFStyle.m_fftrangelo-myIFStyle.m_lo) * m_xs / frange,m_xs-1),1);
	scaleHi=y = __max(__min((int)(myIFStyle.m_fftrangehi-myIFStyle.m_lo) * m_xs / frange,m_xs-1),1);
	if(isrange)
		{
		re.left=x; re.right=y;
		re.top=0; re.bottom=m_ys;
		if(myIFStyle.m_style&IF_STYLE_DEC) 
			{
			FillScopeBack(hdc,re,COL_SCOPE_L,COL_SCOPE_L2);
			//::FillRect(hdc,&re,scopelight);
			}
		else 
			{
			::SelectObject(hdc,ana_range);
			PatBlt(hdc,re.left,re.top,re.Width(),re.Height(),PATCOPY);
			}
		setBorder=1;
		}

	if(myIFStyle.m_style&IF_STYLE_DEC) DrawScaleLines(hdc,m_fftre,m_frqlo,m_frqhi,m_st);

	HFONT hf = (HFONT)::SelectObject(hdc,minifont);
	::SetTextAlign(hdc,TA_TOP); ::SetBkMode(hdc,TRANSPARENT);
	::SetTextColor(hdc,AddBasisColor(COL_SCOPE_P,.15)); 

	::SelectObject(hdc,scopePenP);

	if(myIFStyle.m_style&IF_STYLE_DEC) 
		{
		step=(float)((my_Hight*dbScale)/160.f);		//160dB/5db Grid = 32 lines of 5dB
		o=(160-(160/dbScale))+dbLevel*10;
		m=20;
		if(step>1.8) m=10;
		if(step>5) m=5;
		if(step<0.8) m=40;
		}
	else 
		{
		if(my_Hight>300) {z=11; step=my_Hight/100.f;}
		else {m=20; z=9; step=my_Hight/160.f;}
		}
	
	for(i=0; i<160; i+=(m/2))
		{
		t=(int)((i-o)*step);
		if(t<-10 || t>(m_ys+10) || t>=m_fftre.bottom || t<=m_fftre.top) continue;
		if((i%m)==0)
			{
			::MoveToEx(hdc,m_fftre.left,t,0);
			::LineTo(hdc,m_fftre.right,t);
			if(myIFStyle.m_style&IF_STYLE_DEC) 
				{
				if(i) sprintf(txt,"% 4d",-(i));
				else strcpy(txt,"  0 dB");
				}
			else
				{
				z--;
				if(!t || !z) continue;
				sprintf(txt,"% 2d",z);
				}
			::TextOut(hdc,5,t-5,txt,strlen(txt));
			::TextOut(hdc,m_xs-26,t-5,txt,strlen(txt));
			::TextOut(hdc,m_xs/8*3-40,t-5,txt,strlen(txt));
			::TextOut(hdc,m_xs/8*5+20,t-5,txt,strlen(txt));
			}
		else
			{
			for(x=5; x<m_xs-5; x+=5)
				{
				::MoveToEx(hdc,m_fftre.left+x,t,0);
				::LineTo(hdc,m_fftre.left+x+2,t);
				}
			}
		}

	if(setBorder)
		{
		::SelectObject(hdc,scopePenFilter);
		x = scaleLo;
		if(x && x<m_xs-2)
			{
			::MoveToEx(hdc,m_fftre.left+x,m_fftre.top,0);
			::LineTo(hdc,m_fftre.left+x,m_fftre.bottom);
			}
		
		x = scaleHi;
		if(x && x<m_xs-2)
			{
			::MoveToEx(hdc,m_fftre.left+x,m_fftre.top,0);
			::LineTo(hdc,m_fftre.left+x,m_fftre.bottom);
			}
		}

	if(IFcentermark && IFcentermark<(m_xs-2))
		{
		::SelectObject(hdc,scopeLightDotPenCenter);
		::MoveToEx(hdc,m_fftre.left+IFcentermark,m_fftre.top,0);
		::LineTo(hdc,m_fftre.left+IFcentermark,m_fftre.top+10);
		::MoveToEx(hdc,m_fftre.left+IFcentermark-1,m_fftre.top,0);
		::LineTo(hdc,m_fftre.left+IFcentermark-1,m_fftre.top+7);
		::MoveToEx(hdc,m_fftre.left+IFcentermark+1,m_fftre.top,0);
		::LineTo(hdc,m_fftre.left+IFcentermark+1,m_fftre.top+7);
		::MoveToEx(hdc,m_fftre.left+IFcentermark-2,m_fftre.top,0);
		::LineTo(hdc,m_fftre.left+IFcentermark-2,m_fftre.top+5);
		::MoveToEx(hdc,m_fftre.left+IFcentermark+2,m_fftre.top,0);
		::LineTo(hdc,m_fftre.left+IFcentermark+2,m_fftre.top+5);
		::MoveToEx(hdc,m_fftre.left+IFcentermark-3,m_fftre.top,0);
		::LineTo(hdc,m_fftre.left+IFcentermark-3,m_fftre.top+3);
		::MoveToEx(hdc,m_fftre.left+IFcentermark+3,m_fftre.top,0);
		::LineTo(hdc,m_fftre.left+IFcentermark+3,m_fftre.top+3);

		::MoveToEx(hdc,m_fftre.left+IFcentermark,m_fftre.bottom,0);
		::LineTo(hdc,m_fftre.left+IFcentermark,m_fftre.bottom-9);
		::MoveToEx(hdc,m_fftre.left+IFcentermark-1,m_fftre.bottom,0);
		::LineTo(hdc,m_fftre.left+IFcentermark-1,m_fftre.bottom-6);
		::MoveToEx(hdc,m_fftre.left+IFcentermark+1,m_fftre.bottom,0);
		::LineTo(hdc,m_fftre.left+IFcentermark+1,m_fftre.bottom-6);
		::MoveToEx(hdc,m_fftre.left+IFcentermark-2,m_fftre.bottom,0);
		::LineTo(hdc,m_fftre.left+IFcentermark-2,m_fftre.bottom-4);
		::MoveToEx(hdc,m_fftre.left+IFcentermark+2,m_fftre.bottom,0);
		::LineTo(hdc,m_fftre.left+IFcentermark+2,m_fftre.bottom-4);
		::MoveToEx(hdc,m_fftre.left+IFcentermark-3,m_fftre.bottom,0);
		::LineTo(hdc,m_fftre.left+IFcentermark-3,m_fftre.bottom-2);
		::MoveToEx(hdc,m_fftre.left+IFcentermark+3,m_fftre.bottom,0);
		::LineTo(hdc,m_fftre.left+IFcentermark+3,m_fftre.bottom-2);

		for(int i=m_fftre.top+12; i<m_fftre.bottom-10; i+=4)
			{
			::MoveToEx(hdc,m_fftre.left+IFcentermark,i,0);
			::LineTo(hdc,m_fftre.left+IFcentermark,i+2);
			}
		}

	::SelectObject(hdc,scopePenLine);
	if(style!=IF_STYLE_TOP_TIV)
		{
		::SelectObject(hdc,scopeback.operator HBRUSH());
		::Polyline(hdc,db,m_xs);
		}

	::SelectObject(hdc,hp);
	::SelectObject(hdc,hb);
	::SetViewportOrgEx(hdc,0,0,0);

}
//////// draw scale //////////////////
void MyIFView::DrawScaleLines(HDC hdc, CRect &Scale,int lo, int hi, int st)
{
	HPEN	hp;
	::SetViewportOrgEx(hdc,0,toptop,0); 
	CRect m_re(Scale);
	m_re.bottom++;
	m_re.top++;
	
	int mx = m_re.Width(); 

	SIZE	si;
	int		i,l,x,x1=-1,x2=-1,xz,lx,lolo,end;
	char	buf[32];

	buf[0]=0; int m_bst=0;

	hp=(HPEN)::SelectObject(hdc,scopePenP);
	if(st)
		{
		lx = m_re.left;
		end=m_re.right;

		lolo=lo-(lo%st)+st;
		for(i=lolo; i<=hi; i+=st)
			{
			if(m_bst) 
				{
				sprintf(buf," %.3f ",(double)i/1000.);
				}
			else
				{
				if(st<1000) sprintf(buf," %.1f ",(double)i/1000.);
				else sprintf(buf," %d",i/1000);
				}
			l = strlen(buf);
			GetTextExtentPoint32(hdc,buf,l,&si);
			x = m_re.left + mx * (i-lo) / (hi - lo) - (si.cx >> 1);
			if(x < lx + 2 || x > end-(si.cx>>1)-2) continue;
			if(x + si.cx >end) break;
			xz=x+ (si.cx >> 1);
			if(x1!=xz && x2!=xz)
				{
				::MoveToEx(hdc,xz,0,0);
				::LineTo(hdc,xz,m_re.bottom-1);
				}
			lx = x + si.cx;
			}
		}

	::SelectObject(hdc,hp);
}

void MyIFView::DrawTimeSpec(HDC hdc)
{
	myTSpec.BitBlt(hdc,0,toptop,m_xs,m_ys,0,0,SRCCOPY);

	if(myIFStyle.m_mark>0)
		{
		HPEN hp = (HPEN)::SelectObject(hdc,scopePenMark);
		int	x = __max(__min((myIFStyle.m_mark-myIFStyle.m_lo) * m_xs / frange,m_xs-1),0)+1;
		::MoveToEx(hdc,x,m_fftre.top+1,0);
		::LineTo(hdc,x,m_fftre.bottom+1);
		::SelectObject(hdc,hp);
		}

}

void MyIFView::DrawTopLines(HDC hdc)
{
	HBRUSH	hb=0;
	HPEN	hp=0;
	int		vLO,vHI,xs=myTopViewRect.Width(),ys=myTopViewRect.Height();
	CPen	blackpen(PS_SOLID, 1,AddBasisColor(COL_SCOPE_L,-.15));

	::SetViewportOrgEx(hdc,0,0,0); 

	CRect m_re(myTopScale);
	::FillRect(hdc,&m_re,scopeback);

	vLO=__max(__min((int)(m_viewLO) * xs / m_scale,xs),0);
	vHI=__max(__min((int)(m_viewHI) * xs / m_scale,xs),1);
	hb = (HBRUSH)::SelectObject(hdc,ana_back);
	hp = (HPEN)::SelectObject(hdc,scopePenLine);

	if(myIFStyle.topStyle&IF_STYLE_TOP_TIV)
		{
		//copy the original top spectrum (I save my topTSpec)
		MyDCBitmap	myTSpecRange(topTSpec);
		//simulate an glass effect for the zoom-area 
		myTSpecRange.AddAreaBrightness(vLO,0,vHI,ys,1.12f);	
		//and now draw the new image
		myTSpecRange.BitBlt(hdc,0,0,xs,ys,0,0,SRCCOPY);
		
		//draw a scale split line on the bottom of the FrqScale
		::SelectObject(hdc,scopePenSplitLine);
		::MoveToEx(hdc,myTopScale.left,myTopScale.bottom,0);
		::LineTo(hdc,myTopScale.right,myTopScale.bottom);
		::SelectObject(hdc,blackpen);
		::MoveToEx(hdc,myTopScale.left,myTopScale.bottom+1,0);
		::LineTo(hdc,myTopScale.right,myTopScale.bottom+1);
		}
	else 
		{
		PatBlt(hdc,0,0,xs,ys,PATCOPY);
		if(m_viewHI||m_viewLO)
			{
			::SelectObject(hdc,ana_range);
			PatBlt(hdc,vLO,0,vHI-vLO,t_ys,PATCOPY);
			}
		m_re.left=vLO;	m_re.right=vHI;
		::FillRect(hdc,&m_re,CBrush(AddBasisColor(COL_SCOPE_L,.05))); 

		//scale split line
		::SelectObject(hdc,scopePenSplitLine);
		::MoveToEx(hdc,myTopScale.left,myTopScale.bottom,0);
		::LineTo(hdc,myTopScale.right,myTopScale.bottom);
		::SelectObject(hdc,blackpen);
		::MoveToEx(hdc,myTopScale.left,myTopScale.bottom+1,0);
		::LineTo(hdc,myTopScale.right,myTopScale.bottom+1);

		::SelectObject(hdc,scopePenLine);
		::Polyline(hdc,pt,m_xs);	
		}

	myViewRect.left=vLO;
	myViewRect.right=vHI;
	myViewRect.top=myTopViewRect.top;
	myViewRect.bottom=myTopScale.bottom;

	CDC* pDC=CDC::FromHandle(hdc);
	DrawScale(hdc,myTopScale,myIFStyle.m_radiofrq,myIFStyle.m_radiofrq+m_scale,1000,COL_SCOPE_B2);
	pDC->Draw3dRect(myViewRect,AddBasisColor(COL_SCOPE_B,-.20),AddBasisColor(COL_SCOPE_L,.25));
	myViewRect.DeflateRect(1,1);
	pDC->Draw3dRect(myViewRect,AddBasisColor(COL_SCOPE_B,-.05),AddBasisColor(COL_SCOPE_L,.10));

	::SelectObject(hdc,hp);
	::SelectObject(hdc,hb);
}
//////// draw scale //////////////////
void MyIFView::DrawScale(HDC hdc, CRect &Scale,int lo, int hi, int st, int fill)
{
	HPEN	hp;

	::SetViewportOrgEx(hdc,0,0,0);

	lo-=m_center;
	hi-=m_center;

	CRect m_re(Scale);
	m_re.bottom++;
	m_re.top++;
	if(fill) ::FillRect(hdc,&m_re,scopeback);	

	int mx = m_re.Width(); 
	int my = m_re.Height();

	SIZE	si;
	int		i,l,x,x1=-1,x2=-1,xz,lx,lolo,end;
	char	buf[32];

	buf[0]=0;

	hp=(HPEN)::SelectObject(hdc,scopePenP);
	if(st)
		{
		int		bk=::SetBkMode(hdc,TRANSPARENT); 
		int		tx=::SetTextColor(hdc,COL_SCOPE_LINE);
		HFONT	hf = (HFONT)::SelectObject(hdc,minifont);

		lx = m_re.left;
		end=m_re.right;

		lolo=lo-(lo%st)+st;
		for(i=lolo; i<=hi; i+=st)
			{
			if(st<1000) sprintf(buf," %.1f ",(double)i/1000);
			else sprintf(buf," %d",i/1000);
			l = strlen(buf);
			GetTextExtentPoint32(hdc,buf,l,&si);
			x = m_re.left + mx * (i-lo) / (hi - lo) - (si.cx >> 1);
			if(x < lx + 2 || x > end-(si.cx>>1)-2) continue;
			if(x + si.cx >end) break;
			xz=x+ (si.cx >> 1);
			if(x1!=xz && x2!=xz)
				{
				::MoveToEx(hdc,xz,m_re.top,0);
				::LineTo(hdc,xz,m_re.bottom-1);
				}
			::TextOut(hdc,x,m_re.top + ((my - si.cy) >> 1),buf,l);
			lx = x + si.cx;
			}
		tx=::SetTextColor(hdc,tx);
		bk=::SetBkMode(hdc,bk); 
		::SelectObject(hdc,hf); 
		}


//scale split line
	hp=(HPEN)::SelectObject(hdc,scopePenSplitLine);
	::MoveToEx(hdc,Scale.left,Scale.top,0);
	::LineTo(hdc,Scale.right,Scale.top);

	::SelectObject(hdc,hp);
}



void MyIFView::SetMyScale(int frqlo, int frqhi, int set)
{
	if(frqhi>=60000000)
		{
		frqlo/=1000;
		frqhi/=1000;
		}
	if(frqlo!=m_frqlo || frqhi!=m_frqhi)
		{
		m_frqlo=frqlo;
		m_frqhi=frqhi;
		}
	int w=frqhi-frqlo;
	if(w>100000) m_st=10000;
	else if(w>50000) m_st=5000;
	else if(w>10000) m_st=1000;
	else if(w>5000) m_st=500;
	else m_st=100;

	if(set) RefreschWindow(1);
}

void MyIFView::OnFilterChanged()
{
	if(init)
		{
		myIFStyle.m_lo=(myIFPara.m_lo/10)*10;
		myIFStyle.m_hi=(myIFPara.m_hi/10)*10;
		if(o_lo!=myIFStyle.m_lo || o_hi!=myIFStyle.m_hi) 
			{
			ReSizeSpectrum(1);
			if(myIFPara.m_hi>m_scale)
				{
				myIFPara.m_lo=myIFStyle.m_lo;
				myIFPara.m_hi=myIFStyle.m_hi;
				}
			}
		myIFStyle.m_centermark=m_center;

		switch(myMainFrm->m_mode)
			{
			case REC_LSB:
						myIFStyle.m_fftrangelo=m_center-(myMainFrm->m_filterwidth);
						myIFStyle.m_fftrangehi=m_center;
						break;
			case REC_USB:
						myIFStyle.m_fftrangehi=m_center+(myMainFrm->m_filterwidth);
						myIFStyle.m_fftrangelo=m_center;
						break;
			default:	myIFStyle.m_fftrangelo=m_center-(myMainFrm->m_filterwidth>>1);
						myIFStyle.m_fftrangehi=m_center+(myMainFrm->m_filterwidth>>1);
						break;
			}
		centermark	=CalcValueDouble(myIFStyle.m_centermark-myIFStyle.m_lo,m_xs,frange,0);
		frange = myIFStyle.m_hi - myIFStyle.m_lo;
		SetMyScale(myIFStyle.m_radiofrq+myIFStyle.m_lo,myIFStyle.m_radiofrq+myIFStyle.m_hi);
		}
}

void MyIFView::SetDecScale(int a)
{
	//the DecScale.Poti.Range must be set to 200
	myIFStyle.m_DecScale=a;
	if(a) 
		{
		dbScale=1.f+((float)a/50.f);  //this is the offset value in 1/10 dB;
		}
	else 
		{
		dbScale=1.f;
		}
	RefreschWindow(2);
}

void MyIFView::SetDecLevel(int a)
{
	//the DecLevel.Poti.Range must be set to 200
	myIFStyle.m_DecLevel=a;
	if(a!=100) 
		{
		dbLevel=(float)(a-100)/10.f;  //this is the offset value in 1/10 dB
		}
	else 
		{
		dbLevel=0;
		}
	RefreschWindow(2);
}

void MyIFView::SetLevel(int l)
{
	//the Level.Poti.Range must be set to 270
	myIFStyle.m_level=l;
	if(!l) m_level=0;
	else 
		{
		m_level=0.025f*(float)(-400.f+l);
		}
	RefreschWindow(2);
}

void MyIFView::SetTLevel(int l)
{
	//the Level.Poti.Range must be set to 270
	myIFStyle.topLevel=l;
	if(!l) topLevel=-4.5f;
	else 
		{
		topLevel=0.025f*(float)(-400.f+l);
		}
	RefreschWindow(2);
}

void MyIFView::SetAmpl(int a)
{
	//the Amplitute.Poti.Range must be set to 540
	myIFStyle.m_ampl=a;
	if(a) 
		{
		m_bright = (float)pow(10,((a/8)-10)*.05);
		m_ampl = (float)pow(10,((a/6)-40)*.05);

		}
	else 
		{
		m_bright=m_ampl=0.f;
		}
	RefreschWindow(2);
}

void MyIFView::SetTAmpl(int a)
{
	//the Amplitute.Poti.Range must be set to 540
	myIFStyle.topAmpl=a;
	if(a) 
		{
		topBright = (float)pow(10,((a/8)-10)*.05);
		topAmpl = (float)pow(10,((a/6)-40)*.05);
		}
	else 
		{
		topBright=topAmpl=0.f;
		}
	RefreschWindow(2);
}

float MyIFView::GetDecibelPoint(int x)
{
	int		xx;
	float	data,dB,ldata;
	double	dBValue;
	if(!GetPara.MagData[0]) return 0;

	if(x<0) x=0; 
	if(x>=m_xs) x=m_xs-1;

	dBValue=GetPara.MagData[0][m_fftscal[x]];
	data=(float)(log10(dBValue*dBValue));
	if(m_fftscal[x]!=m_fftscal[x+1])
		{
		for(xx=m_fftscal[x]; xx<m_fftscal[x+1]; xx++)
			{
			dBValue=GetPara.MagData[0][xx];
			ldata=(float)(log10(dBValue*dBValue));
			if(ldata>data) data=ldata;
			}
		}

	dB=160.f/16.f;
	return -(160.f - ((data)*dB)); 

}

void MyIFView::OnMouseMove(UINT nFlags, CPoint point) 
{
	CRect rectClient,topClient;
	if(m_bCaptured)
		{
		CPoint pnt(point);
		//::GetCursorPos (&pnt);
		ClientToScreen(&pnt);
		HWND hw = ::WindowFromPoint(pnt);
		if(hw!=m_hWnd)
			{
			::SetFocus(hw);
			goto raus;
			}
		}

	GetClientRect (rectClient);
	topClient=rectClient;
	rectClient.top=topClient.bottom=toptop;

	if (top_ySnap>0) 
		{
		CPoint ptCursor(point);
		if(point.y>240) 
			{
			ptCursor.y=point.y=240;
			}
		else if(point.y<45) 
			{
			ptCursor.y=point.y=45;
			}

		myIFStyle.topYPos=(short)point.y;
		ptCursor.y=(int)myIFStyle.topYPos;
		ClientToScreen(&ptCursor);
		SetCursorPos(ptCursor.x,ptCursor.y);
		top_ySnap=1;
		ReSizeSpectrum(1);
		return;
		}
	else
		{
		if (point.y>(myIFStyle.topYPos-12) && point.y<(myIFStyle.topYPos+3)) 
			{
			if(!top_ySnap) 
				{
				::SetCursor(m_hcurNS);
				top_ySnap=-1;
				}
			}
		else if(top_ySnap)
			{
			if(top_ySnap) ::SetCursor(m_Hand);
			top_ySnap=0;  
			}
		
		}



	if (rectClient.PtInRect (point))
		{
		if(!m_bCaptured)
			{
			SetCapture ();
			m_bCaptured = TRUE;
			}

		double	Frq,dif;
		dif=frqLO+((double)point.x*frqStep);
		Frq=((double)(myIFStyle.m_radiofrq/1000.)-12.+dif);
	
		if(Frq!=oldFrq)
			{
			oldFrq=Frq;
			sprintf(m_frqtxt,"%.1f kHz",Frq);
			m_frqdelay = 160;

			double db=GetDecibelPoint(point.x);
			double mVolt=pow(10,db*.05)/dBmV;
			if(mVolt>100.) 
				{
				mVolt/=1000.;
				if(mVolt<1.) sprintf(m_dBtxt,"%.2fdB = %.2fmV",db,mVolt);
				else sprintf(m_dBtxt,"%.2fdB = %.1fmV",db,mVolt);
				}
			else 
				{
				if(mVolt<1) sprintf(m_dBtxt,"%.2fdB = %.2fV",db,mVolt);
				else sprintf(m_dBtxt,"%.2fdB = %.1fV",db,mVolt);
				}
	
			RefreschWindow(2);
			}
		if (moveflag)
			{
			if(point.x!=c_down.x)
				{
				double	dir,x;
				if(point.x>c_down.x) {x=(double)(point.x-c_down.x); dir=-1.;}
				else {x=(double)(c_down.x-point.x); dir=1.;}
				dif=((m_scale/my_Width)*dir*x)/1000.;
				dif=dir*(x*frqStep);
				myMainFrm->SetFrq((int)((lastFRQ+dif)*1000.));
				//DraftMode=-1;
				RefreschWindow(2);
				}
			}
		}
	else if (topClient.PtInRect (point))
		{
		if(!m_bCaptured)
			{
			SetCapture ();
			m_bCaptured = TRUE;
			}

		double	Frq;
		Frq=(myIFStyle.m_radiofrq-(myIFStyle.m_IFCenter/1000.))+(((m_scale/my_Width)*point.x)/1000.);
			
		if(Frq!=oldFrq)
			{
			oldFrq=Frq;
			sprintf(m_frqtxt,"%.1f kHz",Frq/1000.);
			m_frqdelay = 20;
			RefreschWindow(2);
			}
		if (moveflag && m_bCaptured)
			{
			double	dir,x;
			if(point.x>c_down.x) {x=(double)(point.x-c_down.x); dir=-1.;}
			else {x=(double)(c_down.x-point.x); dir=1.;}
			myIFControl.SetPosition(lastPOS-(int)((m_scale/my_Width)*dir*x));
			DraftMode=-1;
			RefreschWindow(2);
			}
		}
	else
		{
raus:
		if (!moveflag && m_bCaptured)
			{
			ReleaseCapture ();
			m_bCaptured = FALSE;
			m_frqdelay =0;
			RefreschWindow(2);
			}
		}

	CButton::OnMouseMove(nFlags, point);
}

void MyIFView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	c_down	= point;
	c_last	= point;
	moveflag= 1;
	if (!m_bCaptured)
		{
		SetCapture ();
		m_bCaptured = TRUE;
		}

	if (point.y>(myIFStyle.topYPos-12) && point.y<(myIFStyle.topYPos+3)) 
		{
		top_ySnap=1;
		::SetCursor(m_hcurNS);
		}
	else ::SetCursor(m_FingerDown);
	lastPOS=myIFPara.pos;
	lastFRQ=myIFStyle.m_radiofrq/1000.;
}


void MyIFView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	if (m_bCaptured)
		{
		ReleaseCapture ();
		m_bCaptured = FALSE;
		}
	::SetCursor(m_Hand);
	moveflag=top_ySnap=0;
}

void MyIFView::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	if(point.y<top_ys)
		{
		int width,pos,z=(int)((m_scale/my_Width)*point.x);
		width=(m_viewHI-m_viewLO);
		pos=z-(width/2); 
		if(pos<0) pos=0;
		if(pos+width>m_scale) pos=m_scale-width;
		myIFControl.SetPosition(pos);
		}
	else
		{
		double	dif;	
		dif=frqLO+((double)point.x*frqStep);

		int	frq=(int)((myMainFrm->m_frq-m_center+(dif*1000))+500)/1000; //rund of 1 kHz

		myMainFrm->SetFrq(frq*1000);
		RefreschWindow(2);
		moveflag=0;
		}
}

BOOL MyIFView::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	CRect rectClient;
	GetClientRect (rectClient);

	CPoint ptCursor;
	::GetCursorPos (&ptCursor);
	ScreenToClient (&ptCursor);

	if (rectClient.PtInRect (ptCursor))
		{
		if(GetFocus()!=this) SetFocus();
		::SetCursor(m_Hand);
		return TRUE;
		}
	
	return CButton::OnSetCursor(pWnd, nHitTest, message);
}

BOOL MyIFView::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt) 
{
	ScreenToClient (&pt);
	if (pt.y>toptop) myMainFrm->MouseWheel(nFlags,zDelta,1000);
	else 
		{
		DraftMode=-1;
		myIFControl.p_Width.OnMouseWheel(nFlags,zDelta,pt);
		}
	return TRUE;
}


