// CtrlButton.cpp : implementation file
//
#include "stdafx.h"
#include "../GlobalTools.h"
#include "MyStateLED.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCtrlButton
IMPLEMENT_DYNCREATE(MyStateLED, CButton)
BEGIN_MESSAGE_MAP(MyStateLED, CButton)
	//{{AFX_MSG_MAP(MyStateLED)
	ON_WM_PAINT()
	ON_WM_ERASEBKGND()
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

MyStateLED::MyStateLED()
{
	m_state=0;
	m_dir=DT_LEFT;
	mini=0;
}

MyStateLED::~MyStateLED(){}

void MyStateLED::PreSubclassWindow() 
{
	ModifyStyle (BS_DEFPUSHBUTTON, BS_OWNERDRAW);
	CButton::PreSubclassWindow();
}

BOOL MyStateLED::PreCreateWindow(CREATESTRUCT& cs) 
{
	cs.style |= BS_OWNERDRAW;
	cs.style &= ~BS_DEFPUSHBUTTON;
	return CButton::PreCreateWindow(cs);
}

BOOL MyStateLED::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	dwStyle |= BS_OWNERDRAW;
	dwStyle &= ~BS_DEFPUSHBUTTON;
	return CWnd::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

int MyStateLED::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	lpCreateStruct->style |= BS_OWNERDRAW;
	lpCreateStruct->style &= ~BS_DEFPUSHBUTTON;
	if (CButton::OnCreate(lpCreateStruct) == -1) return -1;
	return 0;
}

void MyStateLED::DrawItem(LPDRAWITEMSTRUCT di) {}
void MyStateLED::OnPaint() 
{
	//flicker subpression

	CPaintDC	pdc(this);
	CDC			dc;
	CRect		rect;
	CBitmap		bitmap;
	CBitmap*	pOldBitmap;

	GetClientRect(rect);
	if (dc.CreateCompatibleDC(&pdc))
		{
		if (bitmap.CreateCompatibleBitmap(&pdc,rect.Width(), rect.Height()))
			{
			pOldBitmap = dc.SelectObject(&bitmap);
			}
		}
	OnDraw(&dc,rect);
	pdc.BitBlt(rect.left,rect.top,rect.Width(),rect.Height(),&dc, 0, 0, SRCCOPY);
	dc.SelectObject(pOldBitmap);
}

void MyStateLED::OnDraw(CDC* pDC,CRect rect) 
{
	CPen		pen;
	COLORREF	col=myDARK;
	CRect		rx,re=rect;
	CString		txt;
	int			center;

	rx=re;
	pDC->FillRect(re,&CBrush(COL_BACK));

	if(mini)
		{
		rx.top+=4;
		rx.bottom-=5;
		if(mini==2) rx.right=rx.left+8;
		else rx.right=rx.left+13;
		re.left=rx.right+2; 
		//re.right=re.left+60;
		}
	else if(m_dir==DT_LEFT) 
		{
		rx.right=rx.left+22;
		center=rx.CenterPoint().y+1;
		rx.top=center-4;
		rx.bottom=center+4;
		re.left=rx.right+2;
		}
	else
		{
		rx.left=rx.right-22;
		center=rx.CenterPoint().y+1;
		rx.top=center-4;
		rx.bottom=center+4;
		re.right=rx.left-2;
		}


	switch(m_state)
		{
		default:
		case DRM_STATE_NOT_PRESENT:	col=COL_BACK; break;		//gray
		case DRM_STATE_CRC_ERROR:	col=RGB(255,40,0); break;	//red
		case DRM_STATE_DATA_ERROR:	col=RGB(255,255,0); break;	//yellow
		case DRM_STATE_RX_OK:		col=RGB(40,240,40); break;	//green
		}

	CBrush filBrush(col);

	pDC->FillRect(rx,&filBrush);
	pDC->Draw3dRect (rx,myDARK, myDARK);

	GetWindowText(txt);

	COLORREF	oldCol=pDC->SetTextColor(COL_BTXT);
	int			BkModeOld= pDC->SetBkMode(TRANSPARENT);
	COLORREF	bkcol=pDC->SetBkColor(COL_BACK);
	CFont		*OldFont; 
	if(mini) OldFont= pDC->SelectObject(&minibigfont);
	else  OldFont= pDC->SelectObject(&fontRegular);
		
	pDC->DrawText(txt, re, m_dir|DT_NOPREFIX|DT_SINGLELINE|DT_VCENTER); 

	pDC->SetBkColor(bkcol);
	pDC->SetBkMode(BkModeOld);
	pDC->SetTextColor(oldCol);
	pDC->SelectObject(OldFont);
}

BOOL MyStateLED::OnEraseBkgnd(CDC* pDC) 
{
	return TRUE;
}

void MyStateLED::SetState(BYTE state, BOOL bRedraw)
{
	m_state=state;
	if (bRedraw && GetSafeHwnd () != NULL)
	{
		RedrawWindow ();
	}
}

void MyStateLED::SetLEDLeft() 
{
	m_dir=DT_RIGHT;
	RedrawWindow ();
}

void MyStateLED::SetLEDRight() 
{
	m_dir=DT_LEFT;
	RedrawWindow ();
}

int MyStateLED::SetXsizeOfContent(int x,int y,int cy,int off)
{
	int cx=GetXsizeOfContent();
	SetWindowPos(NULL,x,y,cx+off,cy,MOVEALL);
	return x+cx+off;
}

int MyStateLED::GetXsizeOfContent()
{
	ASSERT (GetSafeHwnd () != NULL);

	CClientDC dc (this);

	CFont* pOldFont;
	if(mini) pOldFont= dc.SelectObject(&minibigfont);
	else  pOldFont= dc.SelectObject(&fontRegular);

	CString strText;
	GetWindowText (strText);

	CSize sizeText = dc.GetTextExtent (strText);
	dc.SelectObject (pOldFont);
	if(mini) return sizeText.cx+21;
	return sizeText.cx+27;
}
