// MyPanoramaCtrl.cpp : implementation file
//
////////////////////////////////////////////////////
////////////////////////////////////////////////////
// !!! this is not public domain !!!
// You can do what you want if it never hurt bonito.
// Otherwise, you will need the consent of Bonito.	
////////////////////////////////////////////////////
// RadioJet Open Source Project RJ10FiFi
// www.bonito.net/radiojet/opensource
////////////////////////////////////////////////////
////////////////////////////////////////////////////

#include "stdafx.h"
#include "GlobalTools.h"
#include "MyPanoramaCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// MyPanoramaCtrl dialog


MyPanoramaCtrl::MyPanoramaCtrl(CWnd* pParent)
	: CDialog(MyPanoramaCtrl::IDD, pParent)
{
	//{{AFX_DATA_INIT(MyPanoramaCtrl)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void MyPanoramaCtrl::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(MyPanoramaCtrl)
	DDX_Control(pDX, IDC_IF_TOP_OFF,		b_topOFF);
	DDX_Control(pDX, IDC_PA_AMPL_POTI,		p_Ampl);
	DDX_Control(pDX, IDC_PA_WIDTH_POTI,		p_Width);
	DDX_Control(pDX, IDC_PANORAMA_VIEW,		m_View);
	DDX_Control(pDX, IDC_IFSTYLE_DEC,		b_LIN);
	DDX_Control(pDX, IDC_PA_IFSTYLE_TSV,	b_TSV);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(MyPanoramaCtrl, CDialog)
	//{{AFX_MSG_MAP(MyPanoramaCtrl)
	ON_WM_SIZE()
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_IF_TOP_OFF,		OnIfTopOff)
	ON_BN_CLICKED(IDC_IFSTYLE_DEC,		OnSetLIN)
	ON_BN_CLICKED(IDC_PA_IFSTYLE_TSV,	OnSetTSV)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_POTICHANGE,			OnPotiChange)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// MyPanoramaCtrl message handlers

BOOL MyPanoramaCtrl::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	p_Ampl.Init("Bright",255,13,NULL,SET_LEFT);

	myPanoramaStyle.m_ampl=AfxGetApp()->GetProfileInt("PANORAMA","Ampl",0);
	myIQPara.width=AfxGetApp()->GetProfileInt("PANORAMA","Width",myExtRxPara.RTLPara.SampleSets[myExtRxPara.IQ_mode].IQ_freq);
	myIQPara.pos=AfxGetApp()->GetProfileInt("PANORAMA","Position",0);
	myPanoramaStyle.m_style=AfxGetApp()->GetProfileInt("PANORAMA","Style",IF_STYLE_DEC);
	myPanoramaStyle.topStyle=AfxGetApp()->GetProfileInt("PANORAMA","TopStyle",IF_STYLE_TOP_TIV);
	myPanoramaStyle.topOFF=AfxGetApp()->GetProfileInt("PANORAMA","TopOFF",0);
	myPanoramaStyle.topYPos=AfxGetApp()->GetProfileInt("PANORAMA","TopYPos",45);
	
	CRect myRect;
	myMainFrm->GetWindowRect(myRect);
	myRect.top=myRect.bottom-180; if(myRect.top<0) {myRect.top=0; myRect.bottom=180;}

	myRect.top=AfxGetApp()->GetProfileInt("PANORAMA","RectTop",myRect.top);
	myRect.left=AfxGetApp()->GetProfileInt("PANORAMA","RectLeft",myRect.left);
	myRect.bottom=AfxGetApp()->GetProfileInt("PANORAMA","RectBot",myRect.bottom);
	myRect.right=AfxGetApp()->GetProfileInt("PANORAMA","RectRight",myRect.right);

	p_Ampl.Set(myPanoramaStyle.m_ampl);
	p_Width.Set(myIQPara.width);
	b_topOFF.SetCheck(myPanoramaStyle.topOFF);

	AdjustBottons();
	SetCheckPlacement(m_hWnd,myRect,MOVEALL);
	AdjustView();
	InitParameter(ExtIO_TYPE_1); //init FiFi-SDR control onyl
	m_View.SetOff(CLEAR_DRAW); //let's draw
	return TRUE;            
}

void MyPanoramaCtrl::OnCancel() 
{
	if(myExtRxPara.IQ_showGUI) myIFControl.OnShowExtDialog();
	myIFControl.SetExternView(0);
	CDialog::OnCancel();
}

void MyPanoramaCtrl::OnClose() 
{
	if(myExtRxPara.IQ_showGUI) myIFControl.OnShowExtDialog();
	myIFControl.SetExternView(0);
	CDialog::OnClose();
}

void MyPanoramaCtrl::InitParameter(UINT type)   
{
  
	//the type is all times = 1 = ExtIO_TYPE_1
	//for FiFi-SDR to RadioJet 1102S Simulation 

	if(type!=myExtRxPara.IQ_type)
		{
		myExtRxPara.IQ_default=1;
		myExtRxPara.IQ_type=type;
		PepareExtIQDataSet(&myExtRxPara); //set all formal parameters
		}

	myIQPara.m_sample_freq=myExtRxPara.RTLPara.SampleSets[myExtRxPara.IQ_mode].IQ_freq<<1;  
	myIQPara.m_sample_num=(1<<(myExtRxPara.RTLPara.SampleSets[myExtRxPara.IQ_mode].IQ_spow+6));


	int	steps=2000,width=myIQPara.m_sample_freq>>1;
	if(width<60000) steps=1000;
	else 
		{
		if(width<120000) steps=2000;
		else steps=5000;
		}

	p_Width.Init("Width",width,steps,NULL,SET_RIGHT); //spectrum band width in KHz
	p_Width.setValues=width; //view all times the value      

	CString str;
	str.Format(" %d kHz Panorama Spectroscope of the I/Q Receiver FiFi-SDR - OV Lennestadt - O28 / Magazin FUNKAMATEUR / Open Source Examples of Bonito RJ10.DLL",width);
	SetWindowText(str);

	//now init the View 
	m_View.SetOff(DONT_DRAW); //do not draw
	m_View.Init();
	SetFilterParameter();
	m_View.SetOff(RESTORE_DRAW); //restore draw-off-state 
}

void MyPanoramaCtrl::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	if(m_View.init)
		{
		AdjustView();
		m_View.ReSizeSpectrum(1);
		}
}

void MyPanoramaCtrl::AdjustView() 
{
	CRect re,ra,rx;
	GetClientRect(re);
	b_TSV.GetWindowRect(ra);
	ScreenToClient(ra);
	m_View.GetWindowRect(rx);
	ScreenToClient(rx);

	re.top=rx.top;
	re.left=rx.left;
	if(re.Width()>50 && re.Height()>100) m_View.SetWindowPos(NULL,0,0,re.Width(),re.Height(),NO_MOVE);
}

LRESULT MyPanoramaCtrl::OnPotiChange(WPARAM wParam, LPARAM lParam)
{
	int x=(int)lParam;
	int pos=lParam;

	if((HWND)wParam==p_Ampl.m_hWnd)
		{
		SetAmpl(lParam);
		}
	else if((HWND)wParam==p_Width.m_hWnd)
		{
		SetWidth(lParam);
		}
	return NULL;
}

void MyPanoramaCtrl::SetWidth(int pos)
{
	if(pos <1000) pos=1000;
	int mid=((myIQPara.m_hi+myIQPara.m_lo)/2)-(pos/2);
	if(mid<0) mid=0;
	myIQPara.pos=mid;
	myIQPara.width=pos;
	SetFilterParameter();
}

void MyPanoramaCtrl::SetPosition(int pos)
{
	myIQPara.pos=pos;
	SetFilterParameter();
}

void MyPanoramaCtrl::PotiNormalisation()
{
	int lo,hi,max=myIQPara.m_sample_freq>>1;

	if(myIQPara.width >max) myIQPara.width	=max;
	if(myIQPara.pos  >max) myIQPara.pos	=max;
	if(myIQPara.width <1000) myIQPara.width	=1000;
	if(myIQPara.pos	<0) myIQPara.pos=0;

	lo=myIQPara.pos;
	hi=lo+myIQPara.width;
	if(hi>max)
		{
		lo=max-myIQPara.width;
		hi=lo+myIQPara.width;
		}
	
	myIQPara.width=hi-lo;
	myIQPara.pos=lo;

	int pos=(int)((float)myIQPara.width/20.f+.5f)*20;

	p_Width.Set(pos);
	p_Ampl.Set(myPanoramaStyle.m_ampl);

	myIQPara.m_lo=int(lo);
	myIQPara.m_hi=int(hi);
}

void MyPanoramaCtrl::SetAmpl(int ampl) 
{	
	myPanoramaStyle.m_ampl=ampl;
	p_Ampl.Set(ampl);
	m_View.SetAmpl(myPanoramaStyle.m_ampl);
	m_View.RefreschWindow(2);
}

void MyPanoramaCtrl::SetFilterParameter() 
{
	PotiNormalisation();
	m_View.OnFilterChanged();
	m_View.RefreschWindow(2);
}

void MyPanoramaCtrl::OnIfTopOff() 
{
	if(myPanoramaStyle.topOFF) myPanoramaStyle.topOFF=0;
	else myPanoramaStyle.topOFF=1;
	b_topOFF.SetCheck(myPanoramaStyle.topOFF);
	m_View.ReSizeSpectrum(3);
}

void MyPanoramaCtrl::AdjustBottons()
{
	int m_style=myPanoramaStyle.m_style&IF_STYLE_MASK;
	b_topOFF.SetCheck(myPanoramaStyle.topOFF);
	b_TSV.SetCheck(m_style&IF_STYLE_TIV);
	b_LIN.SetCheck(myPanoramaStyle.m_style&IF_STYLE_DEC);
}

void MyPanoramaCtrl::OnSetTSV() 
{
	myPanoramaStyle.m_style=IF_STYLE_TIV;
	m_View.RefreschWindow(2);
	AdjustBottons();
}

void MyPanoramaCtrl::OnSetLIN()
{
	myPanoramaStyle.m_style=IF_STYLE_DEC;
	m_View.RefreschWindow(2);
	AdjustBottons();
}
