// RJ10_GPIO.h : main header file for SI570 
//
#if !defined(RJ10_HID_DLL)
#define RJ10_HID_DLL

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#pragma pack(push)
#pragma pack(1)

#include <afxtempl.h>

#define UBYTE	unsigned char



#define IFJET_VID	(unsigned int)0x0D8C	// Vendor ID
#define IFJET_PID	(unsigned int)0x0132	// Produkt ID of the RadioJet Device



//////////////////////////////////////////////////////////////////////////////
//////////////////////////////RadioJet IF-1102////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

typedef struct	{
				char	SerialNr[20];	
				char	VendorName[64];		
				char	ProductName[64]; 
				char	AudioDeviceName[64]; 
				}HID_DEVICE;
typedef	CArray<HID_DEVICE,HID_DEVICE&> HIDDevices;

//////////////////////////////////////////////////////////////////////////////

typedef struct HID_ATTRIBUTES { 
    ULONG   Size; // = sizeof (struct HID_ATTRIBUTES) 
 
    // 
    // Vendor ids of this hid device 
    // 
    USHORT  VendorID; 
    USHORT  ProductID; 
    USHORT  VersionNumber; 
 
    // 
    // Additional fields will be added to the end of this structure. 
    // 
} HID_ATTRIBUTES, *PHID_ATTRIBUTES; 
typedef PVOID HDEVINFO; 

#define DEVICE_NOT_READY	0		//device now disconnected or OFF (if it was connected)
#define DEVICE_READY		1		//device found and OK
#define DEVICE_NOW_READY	2		//device is now ready for new connection 
#define DEVICE_NOT_FOUND	-1		//device not connected and not found 
#define DEVICE_IS_WAITING	-99		//device is waiting for DEVICE_CHANGE 

class RJ10_GPIO 
{
public:
						RJ10_GPIO();
			virtual		~RJ10_GPIO();

	HINSTANCE			hhid; 
	HANDLE				HIDHandle,CheckHandle;
	HDEVINFO			PnPHandle; 

	int					LoadHidDll(); 
	void				UnloadHidDll(); 
	int					GetDeviceList(); 
	void				HIDCleanup(); 
	void				CleanFileHandle();
	void				CleanCheckHandle();
						
 	void				(WINAPI* HID_GetHidGuid)(LPGUID HidGuid); 
	BOOLEAN				(WINAPI* HID_GetAttributes)(HANDLE HidDeviceObject, PHID_ATTRIBUTES Attributes); 
	BOOLEAN				(WINAPI* HID_GetManufacturerString)(HANDLE HidDeviceObject,PVOID Buffer,ULONG BufferLength); 
	BOOLEAN				(WINAPI* HID_GetProductString)(HANDLE HidDeviceObject,PVOID Buffer,ULONG BufferLength); 
	BOOLEAN				(WINAPI* HID_GetIndexedString)(HANDLE HidDeviceObject,ULONG Index,PVOID Buffer,ULONG BufferLength); 

};
#pragma pack(pop)
#endif // !defined(CM119_HID_DLL)
